commit b617f80ca5d386c1c248bab64276a9f283173a21
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jun 1 07:57:27 2016 +0100

    compat: Another day, another ABI change for OsBlockSGIO
    
    Now OsBlockSGIO/OsReleaseSGIO are back in the headers, but we include
    compat-api.h too early so we do not remove them. Instead, move the
    avoidance inline.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7337f558d8bae26e626305fc478d070368bd86cd
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue May 31 09:32:31 2016 +0100

    sna: Use physical output size from the kernel
    
    We have a conflict between Xorg and the kernel, once again, over the
    meaning of the EDID. Since the kernel supplies us with the physical size
    of the connector, let's place the burden of trust on the kernel and
    ignore the quirky behaviour of Xorg.
    
    Suggested-by: Ville Syrjälä <ville.syrjala@linux.intel.com>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=96255
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 000378a801d627687a34906193c9f75b5041c7da
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon May 30 16:01:03 2016 +0100

    compat: Add OsBlockSIGIO/OsReleaseSIGIO wrappers
    
    Signal-driven cursor are removed in ABI_VIDEODRV_VERSION 22.0.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4458f1bf8a5cfbed0c4bbe9d968719c47ee0ea7d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat May 28 19:23:38 2016 +0100

    sna: Restore TearFree operation after switching everything off
    
    We give up on TearFree if we ever see an error whilst page flipping (in
    the hope that we can keep displaying via direct use of the scanout).
    With the advent of MST, this can happen simply by the user unplugging a
    dock causing connectors to disappear and if we flip before we see the
    uevent telling us which outputs are disabled, we get an error.
    
    So, lets try and re-enable TearFree on the next opportunity, when all
    the outputs are off and we can rebuild the shadow buffer.
    
    Reported-by: Martin Jørgensen <mkj@gotu.dk>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=96180
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 46ffdf295d161a70459508ef0643d70af66ed990
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 22 18:31:50 2016 +0100

    sna/dri2: Avoid chaining swaps across a mode change
    
    If the pixmap on a drawable changes between swap events, just queue a
    normal vblank event rather than chaining up.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2205da072943664ba0685630436cb57fc6342b44
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 22 18:20:06 2016 +0100

    sna: Display errno when SETCURSOR fails
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8477615ae1bd284aca1221185ffefe0630d3f7ab
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 22 14:18:20 2016 +0100

    sna: Allow disconnected outputs to retain state without EDID checks
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 25d2c2d049a8c9f2b2ef0895d6079c8b273ad121
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed May 18 23:26:12 2016 +0100

    sna: Confirm the EDID is the same after a hotplug before ignoring
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit a508b11bde9f3119b49b3e0f652587efb9e037af
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue May 17 07:55:03 2016 +0100

    sna: Don't skip migration-to-GPU for TearFree
    
    In 46caee86db0f ("sna: Fix reporting of errno after setcrtc failure"),
    the intention was to avoid reporting a fail to migrate whilst wedged for
    a simple copy from the frontbuffer to TearFree's shadow buffer. However,
    by skipping the migration, we never flushed any dirt from the CPU buffer
    prior to doing the TearFree flip.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=95401#c7
    References: https://bugs.freedesktop.org/show_bug.cgi?id=95414#c4
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 48569eb18d125e20aa817549506fc4c1609829c9
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue May 17 07:45:46 2016 +0100

    sna: Track the minimum damage when doing CRTC-local TearFree
    
    We avoid having to redraw the entire CRTC's buffer on every flip as we
    know the contents from the previous flip are still available and only
    need to invalidate the dirty region.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ab3ab412a459a95e94707a4e39a18790ee04e6e3
Author: Chris Bainbridge <chris.bainbridge@gmail.com>
Date:   Tue May 17 07:26:10 2016 +0100

    sna: Fix increment of modeset serial after applying CRTC
    
    We track how many mode sets have been made in order to detect stale
    flips (i.e. a sequence that crosses a mode change). This was broken by
    the logic inversion in setcrc in 46caee86db0f ("sna: Fix reporting of
    errno after setcrtc failure")
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=95401
    Signed-off-by: Chris Bainbridge <chris.bainbridge@gmail.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 34f63f28c8f39e1d64cd159482f86cacbbff05b4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon May 16 10:14:04 2016 +0100

    sna: Ensure we only cache the local CRTC scanout buffer
    
    Double check that we are not about to cache the common, untransformed,
    shadow buffer for the per-CRTC transformed buffer.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3a7d6afd85f85b8b10bf0c08b7b5fa5265624850
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat May 14 16:13:33 2016 +0100

    sna: Do not cache the current crtc bo after performing the setcrtc
    
    When doing a SETCRTC as a fallack for a failed pageflip, do not use the
    then current CRTC bo as the next bo for pageflipping - as then we will
    render into it prior to flipping and so cause tearing.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=95401
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f71447998cc8e22570cd5641bcf008cb68e9f4a3
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat May 14 09:00:08 2016 +0100

    sna/dri2: Refactor open-coded __kgem_bo_is_busy
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3c95efe5f7989d95153f527eb7d2946d3bbc2af1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat May 14 08:49:46 2016 +0100

    sna/dri2: Force blocking wait if vblank queue fails
    
    Whilst waiting for the previous blit to complete, if we fail to queue
    the vblank to wake up on the next frame, block before replying the blit
    is complete.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 1486cfdf04b070787074493a30cd698455b016fe
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri May 13 22:53:26 2016 +0100

    sna/gen6+: Don't force a switch to BLT if the target bo cannot be blitted
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 512284fd47bc225236e403920647703ea4842666
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon May 9 21:11:13 2016 +0100

    sna/dri2: Enforce swap-limits on stale buffers
    
    If the client sends an out-of-date swap request, first make sure that we
    don't cause an error by chasing a NULL CRTC and secondly force them to
    wait for a whole vblank before the next swap.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 88733a7874f7c9b45da5d612802947a9de12893a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat May 7 15:36:53 2016 +0100

    sna/dri2: Force consideration of the DRI2CopyRegion source as unclean
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 08865b0af288e0460c38c2e3ca20a7f9d0311f27
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat May 7 15:24:28 2016 +0100

    sna: Add a special case for fast DRI2CopyRegion and NoAccel
    
    Enable copying onto a scanout buffer using a WC mmap - so long as it is
    X-tiled and no swizzling.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b89f203b0d65b607bc906b9a1ac184ebef7b41df
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat May 7 15:20:32 2016 +0100

    sna: Do not force ping-pong migration for TearFree + NoAccel
    
    If acceleration is disabled, but we are using TearFree, then ideally we
    want to flip the shadow buffer onto the scanout. If the shadow buffer is
    already on the GPU, e.g. having been swapped in by a compositor, then we
    do not want to move it to the CPU domain only to copy it back to a new
    buffer and then flipped for a TearFree update.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 47cd7fdd0b0fe004c77b1c7862161d8968af2cc2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed May 4 11:09:51 2016 +0100

    test: Exercise XVidMode switching
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e4ef6e9e5b2c8b637356621c60b28d064d40d29c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Apr 30 14:09:05 2016 +0100

    sna/dri2: Free the pending back buffer after use
    
    The pending back buffer is only the pending copy, the actual info->back
    stores the client's view of the current back buffer which may be more
    recent than the pending copy. So store the current back buffer, swap in
    the pending to do the normal swap, then free the resultant back (which
    may have been exchanged with the front), before restoring the client's
    current back buffer.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=95200
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit bca4e0e35e4ac27f2dcd1a8e5fcbf7ce69cec358
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Apr 23 21:42:12 2016 +0100

    sna: Limit generic convolution to smallish kernels
    
    Since the naive implementation uses an 8bit temporary, we can only
    support so many passes before the quantization artefacts become
    apparent. We have to be extra conservation in order to support
    multi-pass convolution algorithms (notable 2-pass separable Gaussian
    kernels).
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=95091
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit cac8e1ee74fa8704a42a5c5ebe65d5ec777cbd67
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 22 21:28:34 2016 +0100

    uxa: Enable Y-tiling BLT support
    
    Mesa wants to pass Y-tiled framebuffers onto scanout. Admittedly, this
    isn't quite that but it does prevent them being jumbled up.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 46caee86db0fb32b16213893c79d9c1a21ed0883
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 20 21:37:35 2016 +0100

    sna: Fix reporting of errno after setcrtc failure
    
    As we now do more syscalls after the setcrtc, we cannot rely on errno
    storing the pertinent error code. Instead we have to save it immediately
    after the drmIoctl() and propagate that back.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c62177ec321e009a1abcdc969dd808fb37136013
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 20 21:31:46 2016 +0100

    sna: Force the shadow buffer even after we fail to set the crtc for TearFree
    
    As the first choice of orientation and tiling may be invalid, e.g.
    left/right rotation on Skylake, we need to force the second pass here to
    try and an alternate non-native rotation.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 562ae1f29fd4946c5204bacc9eaa4ee13e809753
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 18 20:56:05 2016 +0100

    sna/present: Postpone recursed vblank during TearFree by 1ms
    
    Avoid postponing until the next vblank to avoid continually recursing
    every TearFree update, and to minimise the presentation delay.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=94982
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 680ae24ea9ae050a126d7e31054f04a6182c2aa4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 17 18:58:09 2016 +0100

    sna: Block SIGIO when we are trying to flip
    
    Temporarily stopping the pointer whilst we try to queue the flip should
    help keep the output latency down.
    
    Reported-by: Rafael Ristovski <rafael.ristovski@gmail.com>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=94980
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 81029be07380090195d165fab91d3e1fe1d84bb9
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 17 15:59:36 2016 +0100

    sna/gen8+: Flush pipecontrols when forcing a pipeline stall
    
    In order to actually stall the pipeline completely and to wait for
    earlier flushes to complete, we have to set a flag in the pipecontrol.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f7f5ef714f79be362edb6a59de4ff02d4c235b5e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 17 14:24:26 2016 +0100

    sna: Tweak flushing before adding a new bo into a batch
    
    Try to reduce the frequency we flush between operations, to only
    consider known-idle bo.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 29b70ccdf67ee7afa19bed26de8678476ba94f6e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 17 15:02:46 2016 +0100

    sna/present: Fix requeuing after interrupting TearFree
    
    Increment the target_msc by one, not the last known msc!
    
    Reported-by: Rafael Ristovski <rafael.ristovski@gmail.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f2a46458a257777438361f74d7e6abee92c7f294
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Apr 16 18:12:04 2016 +0100

    sna: Fix alignment vs length check when adjusting dst pointer
    
    When doing the misaligned copy from the start of the dst pointer, the
    important check is whether there is enough bytes remaining to the next
    alignment position, next from the last.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=94928
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c3dc8310575acdbbef4565f53644384c7ce4a6f5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 15 19:34:15 2016 +0100

    sna: Mark the transformed cursor image as dirty
    
    So that when we size from transformed cursors to non-transformed, we
    remember to clear the entire area.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d30d276aeebe666e2c71a275bb2c71781c75448b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 15 19:26:34 2016 +0100

    sna/blt: Reuse computed partial tile offset in copy_from_tiled
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit bb69256b5270b6ff64a87db4eb308f1cc856679c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 15 15:16:00 2016 +0100

    sna/gen6: Encourage migration of small BLT operations
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 0d38419cbeaae5f8b5260e4d4dd9cfa0d2694eae
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 15 14:58:57 2016 +0100

    sna/gen9: Update mocs selection
    
    Since the choice is now boolean (use PTE or use WB), remove the third
    uncached condition.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit a7526ea2e038f1f1bb92869f584d2fe4c8db1dce
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 10 16:46:46 2016 +0100

    sna/present: Prevent recursion when handling TearFree waits
    
    When draining the flipqueue for TearFree, we may recurse from the vblank
    handlers. Avoid this by delaying the Present vblank until next frame.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b6917eced7b2a96ec2432eac924a526e94371643
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Apr 9 20:45:29 2016 +0100

    sna: Restict reduction of ADD white when we have compatibile formats
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6c07f467a347ea35b682fe4d21c5071adcf4e2aa
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Apr 9 20:12:03 2016 +0100

    sna: Apply the precomputed BLT colors for SRC reductions
    
    Eek, after computing what the resultant color should be, we should
    endeavour to use it!
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d08221edabc58bf7aab27931235d1746407bacb0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Apr 9 18:57:29 2016 +0100

    sna: Replace lost offset when copying from tiled memory
    
    Fixes typo from 28e3bdd7584c5c5a441f19d5cda64024a9cebf5c
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit de44aaa2dd02e68ec94bd011fdd4190393433ba0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 8 21:07:10 2016 +0100

    sna/present: Refuse to queue a vblank on a disabled CRTC
    
    Kick the error back to the upper layer for it to sort out.
    
    Reported-by: Timo Aaltonen <tjaalton@ubuntu.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit edcfb3efb87c5d70f821a65e8e197b1a607706ae
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 8 20:56:26 2016 +0100

    sna/present: Handle 64bit wraparound in msc comparisons
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e5bbf519bd2a62f770f2bf964857855d45036256
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 8 20:49:13 2016 +0100

    sna/present: Fixup msc when reporting a fake vblank with 0 delay
    
    If we have to fake a vblank because the CRTC is off and we compute the
    delay as being 0, then we would report the event immediately - but with
    the earlier msc. Instead, we want to report the completion.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e783ffa4977ae63a7192a5905fe0d8ccd055ee8e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 8 15:01:43 2016 +0100

    sna/gen9: Bias GT for pipeline selection
    
    Each GT on Skylake is bigger than previous generations. For reusing the
    placement logic, we then want to pretend that Skylake has a higher
    GT-equivalence.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 15903e7c687705d084d8eadfd7b11c35dc0b247d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 8 10:59:36 2016 +0100

    sna: Avoid rep mov (builtin memcpy) for WC writes
    
    Lesson learnt, rep mov is terrible when applied to WC.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ab041b9b91b9bd65861b8a4c30ea8d776041e56d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 8 08:34:20 2016 +0100

    sna: Specialise alignment paths for storing
    
    Switch between aligned/unaligned stores for the bulk copy inner loops.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e62010374c0ffd1b0103285a4bf5572ce0359f51
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 8 08:24:44 2016 +0100

    sna: Unroll the innermost SSE2 loop one more time
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 27ec7e49daca956733b2756dc6ae3c3eda4dd56b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 8 08:03:11 2016 +0100

    sna: Force inlinement of SSE2 builtins
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 65c72d9871fed7db47b5d5a2abdd43566844dcd5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 8 07:56:07 2016 +0100

    sna: Invert the function wrapping for sse64xN/sse64
    
    We should be consistent in making the code simpler for the compiler and
    so not rely on it eliminating the dead-code for a single loop of
    sse64xN!
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 59d371a9b215fdcd6139279435af7e1f6803309e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 7 21:55:13 2016 +0100

    sna: Don't limit CRTC id
    
    Don't bake in the assumption that the CRTCs will always be allocated in
    the low byte of the identifiers range. It is only used in a pair of
    other functions (Xv plane updates), so not a big deal.
    
    Reported-by: Mark Kettenis <kettenis@openbsd.org>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 28e3bdd7584c5c5a441f19d5cda64024a9cebf5c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 7 18:39:47 2016 +0100

    sna: Fixup SSE2 alignment instructions for copying to client memory
    
    Only the tiled surface alignment is known, the client we must assume is
    unaligned.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d4818c74b19e8c75729573c75350dd9ee587d217
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 7 14:14:15 2016 +0100

    sna/present: Clamp to maximum timer delay
    
    Timers can only be set for a maximum of int32_t milliseconds into the
    future. Respect that - if we need more, we'll just requeue!
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 74b755fe0a786d330d121c435d274e2418003581
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 6 22:50:28 2016 +0100

    sna/present: Clear flags on the vblank event's CRTC early
    
    We store a flag on the vblank's CRTC to indicate whether we have marked
    the target CRTC as having an immediately pending vblank. We should clear
    this set of flags early so that we don't have to worry about the flag
    whilst processing the vblank, and so that we don't get confused if we
    have to requeue the vblank.
    
    Reported-by: Christoph Haag <haagch@frickel.club>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=94829#c32
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2077272b12ab299e1f25a16408476da0b51477b7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 6 20:48:43 2016 +0100

    sna/blt: Don't skip the final src/dst_stride adjustment
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8d3c8a6c0d48883ec399f8dd36df0eca200722f9
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 6 19:43:41 2016 +0100

    sna: Restrict sse2 routines to __x86_64__
    
    After fixing the 32bit build (sigh), testing out the manual unwinding of
    the sse2 memcpy doesn't look worthwhile (at least on pnv). So leave it
    off for 32bit builds.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4d220adcaddd64f86f810693c361dbb093076858
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 6 18:44:07 2016 +0100

    sna: Mark sse2 routines as "fast"
    
    Trying to unify all the target attributes to chase down:
    
    blt.c: In function ‘memcpy_from_tiled_x__swizzle_0__sse2’:
    blt.c:345:1: error: inlining failed in call to always_inline
    ‘memcpy_sse64xN’: target specific option mismatch
     memcpy_sse64xN(uint8_t *dst, const uint8_t *src, int bytes)
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b3a2d6c84ec4e07b1e25a422a84d3d9fae3edaa2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 6 18:13:06 2016 +0100

    sna: Manually expand sse2 memcpy to compensate for a bad compiler
    
    Eek, this doubles the memcpy performance on skl with gcc-4.8. Still, not
    ideal.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4e172a38e1707465c189c56bdb7ee4bdaf54c9d4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 6 15:38:19 2016 +0100

    sna/gen9: Quick and dirty implementation
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ff0ab2c2eadfb832e1e1393b6664b214e0a31a3b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 6 10:03:36 2016 +0100

    sna/present: Only compensate the timer delay on the final frame
    
    For delays over a frame, we aim to fire a frame early and so
    compensating again for less than a whole frame is irrelevant.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit a76560107f7d97b80d47e90b46535a8aba273c32
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 6 09:23:05 2016 +0100

    sna/present: Only use the HW vblank for the last frame
    
    Rather than queuing vblanks for future events up to 4000 years and
    setting the hardware to stay awake for all that period (reporting a tick
    every refresh), use the timer for the first part. (The timer should
    allow a precise-(ish) single wakeup of the hardware.) We set the timer a
    frame ahead, so that we can then queue an actual hw event for the final
    vblank for precision.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=94829
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 9ce7d47a867880b7b43eded7ef8e2d09c5dc21ea
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 6 08:55:14 2016 +0100

    sna/present: Skip the unflip if a no-op
    
    If the screen is already scanning out from the desired framebuffer
    (because we failed when flipping and already restored the mode), skip
    the unflip.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=94829
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit afddc9fe7fd0bd8b960f4202071bffec02744f87
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Apr 5 21:35:37 2016 +0100

    sna/present: Arm the fake vblank timer to wake up one frame early
    
    If we wake up early from the timer, we can use the hw to give us a more
    precise wakeup for the vblank (rather than estimating to the approximate
    millisecond).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e091ace4d861bbcd67d69f409f0cdf365ee2e685
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Apr 5 20:01:07 2016 +0100

    sna/present: Remove stale assert that fake vblanks only have one event
    
    Since commit 02f535e8f3659f1147c6f2e698bd5d8730dec19b
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Thu Mar 24 09:39:06 2016 +0000
    
        sna/present: Requeue early vblank completions
    
    we may hit the fake vblank timer path with an old hw struct that may have
    multiple associated events. The assert that we only called the fake
    vblank from sna_present_queue_vblank is no longer correct.
    
    Reported-by: Christoph Haag <haagch@frickel.club>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=94829#c15
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4b4324cd059590cbeb37b6d6fd79446171cd04c4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Apr 5 20:01:07 2016 +0100

    sna/present: Update the vblank timestamp after a blocking wait
    
    After doing a blocking wait (rather than event driven) for the imminent
    arrival of the next frame (when it is expected less than 1ms in the
    future), update the timestamp and frame counter that we then report back
    to present.
    
    Reported-by: Christoph Haag <haagch@frickel.club>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=94829#c15
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f4ce7fee6cb760353ce1fef9272e927461d8a21b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Apr 5 19:12:29 2016 +0100

    sna/present: And drop bogus queued assertion
    
    Don't forget that along the vblank path, we may use a timer instead of
    the hw event in which case, we don't actually count the info as queued
    (to hardware)
    
    Reported-by: Christoph Haag <haagch@frickel.club>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=94829#c13
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 84c545b1b76e9c2ca99c0bb2f395931e259c0df8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Apr 5 18:27:51 2016 +0100

    sna/present: Markup hw vbanks queued after a fake vblank
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 65dc4176d84e1d1764a6fa1edc972aa7f1dcd2ba
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Apr 5 17:53:55 2016 +0100

    sna/present: Prevent reporting an incomplete event
    
    If we cancel a flip, we may try to restore the current mode and this may
    flush the partial flip (in a multi-monitor setup). We report the completed
    event back to present and free the event info. Then we report the error
    back to present, and free the event info a second time. Chaos and
    corruption ensues.
    
    Reported-and-tested-by: Christoph Haag <haagch@frickel.club>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=94829
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit bb5194eebd72e828a46f504d91f1ecd5b5804f57
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Apr 5 06:51:46 2016 +0100

    sna: Add alignment hints to tiled memcpy
    
    Telling the compiler the known alignment should improve the memcpy
    operation, but only has a small impact today (a few bytes/instructions
    per function).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 90792c933d9a6160e6646121cfe79ee857f70655
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 3 20:16:47 2016 +0100

    sna: Only print "Failed to prepare CRTC ... disabling TearFree" once
    
    The actual disablement doesn't take place until the next modeset, and
    until then we are likely to keep spamming the error message.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=94806
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2c4890001db18cc0534dd4a1f8d09c5df72c9404
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 31 19:43:07 2016 +0100

    sna/video: Use the GPU to prescale overlay sprites
    
    Since Haswell, we lost the ability to use hardware scalers on the
    overlay planes. Allow Xv clients to pass in unscaled data and use the 3D
    pipe to prescale the images before display.
    
    (I doubt I have the rotations corrected!...)
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3fafabe56241c7180a8b7d1896b1c6d7e4999ba2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 31 12:31:41 2016 +0100

    sna/dri3: Ensure foriegn bo are marked as unclean on creation
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ebe86fdaa9aa13de3d1952c5d7a62bf36e834455
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 30 14:31:18 2016 +0100

    test/dri2-race: Don't leak the Display after detecting the race
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 094924f7f882da1f32395d4c982db6ad8e0f609f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Mar 25 20:59:48 2016 +0000

    tools/cursor: Print an ASCII representation as well
    
    Show the ASCII outline of the cursor as well as the image stored in the
    PNG.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 39fbae3c61cc2d78ac5e7c5c471d161fafd53400
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 24 22:09:48 2016 +0000

    Update i915_pciids.h
    
    Sync with kernel commit 7157bb27e79875db5603aa1e30f56e873a8300f9
    Author: Michał Winiarski <michal.winiarski@intel.com>
    Date:   Fri Feb 5 13:21:42 2016 +0100
    
        drm/i915/skl: Add missing SKL ids
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 03bed1c7ba838af9aa6ab722aeaa070aa4cc70e3
Author: Lyude <cpaul@redhat.com>
Date:   Wed Mar 23 15:44:37 2016 -0400

    uxa: Restore old bo on failure
    
    When we fail to do a modeset, we need to make sure that we restore the
    previous bo in the event that it's changed. Otherwise we'll crash the X
    server the next time we do a pageflip.
    
    This fixes an issue with panning crashing the X server if a user tries
    to set a large panning resolution such as 5200x3200, and the GPU doesn't
    have enough memory to handle the bo due to being in UXA mode.
    
    Signed-off-by: Lyude <cpaul@redhat.com>
    Reviewed-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c186d4dda3b62b73af3caf2883a9cedfd97e3b45
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 24 18:22:20 2016 +0000

    sna/present: Restrict vblank.sequence range to 31bits
    
    The kernel checks for past vblanks using an int32_t comparison, so we
    can only program up to 31bits into the future (and similarly programing
    a timer that large would also overflow).
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=94685
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4e108afe55f6b13aa946d1252ff0b828929245b3
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 24 12:28:59 2016 +0000

    Revert "configure: Remove test for strlcat"
    
    This reverts commit e4e469a0ede6974e1f916843f9317244516f7674.
    
    It looks like we get to choose between breaking the clang build or the
    gcc build. With gcc, we need to ensure that enter xorg/os.h with the
    right set of HAVE_STRNDUP et al guards, e.g.
    
    In file included from /usr/include/string.h:630:0,
                     from /usr/include/xorg/os.h:53,
                     from /usr/include/xorg/misc.h:116,
                     from fd.c:34:
    /usr/include/xorg/os.h:590:1: error: expected identifier or '(' before '__extension__'
     strndup(const char *str, size_t n);
    
    Reported-by: Arkadiusz Miskiewicz <arekm@maven.pl>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c326ed192bcaeea41bb93b7077ec37a1437a4409
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 24 11:38:35 2016 +0000

    sna/present: Add missing "static inline" for disabled present stubs
    
    Oops, copy'n'paste broke the non-Present build:
    
    sna_trapezoids_boxes.c:(.text+0x0): multiple definition of
    `sna_present_cancel_flip'
    
    Reported-by: Sedat Dilek <sedat.dilek@gmail.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f6316fb6f04a61857995aa9fb757249fe3fbaebd
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 24 11:03:07 2016 +0000

    configure: Remove ACLOCAL_FLAGS passthrough
    
    Still not working right, remove it to keep the standard build working.
    Sorry if you have been relying on ACLOCAL_FLAGS.
    
    Reported-by: Sedat Dilek <sedat.dilek@gmail.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e4e469a0ede6974e1f916843f9317244516f7674
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 24 11:01:52 2016 +0000

    configure: Remove test for strlcat
    
    There's no point in testing for functions we don't use and seem to cause
    problems for Clang.
    
    Reported-by: Sedat Dilek <sedat.dilek@gmail.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 02f535e8f3659f1147c6f2e698bd5d8730dec19b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 24 09:39:06 2016 +0000

    sna/present: Requeue early vblank completions
    
    If the vblank completes too early (e.g. due to a modeset), try
    requeueing it so that it fires at the expected time (and so after the
    modeset).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 1b82b7b48d17b4b3401e9d82b0fe86df06c8d451
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 24 10:31:02 2016 +0000

    sna/present: Cancel pending unflips when resizing the screen
    
    Otherwise we try to flip back before we complete the mode change.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f656f6afa288c63968f45d6d32c96a4cf6213117
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 22 22:11:18 2016 +0000

    sna/present: Report BadValue if target_msc exceeds last known msc by 1<<32
    
    As we cannot queue a vblank further than 1<<32 into the future, nor can
    we set a Timer to expire that far into the future, creating such a
    vblank event is futile. Report BadValue and hope for the best.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=94515
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 74cd4d09ae051d3a1f4cb9fe29e656b044f03ece
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 16 17:35:26 2016 +0000

    sna: Ensure the scanout is fully flushed on LeaveVT
    
    Just in case we haven't otherwise flushed and invalidated the scanout
    prior to loosing control of the output.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 68913715a2982572e88f943fd4fbe1b07e2fc720
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 16 13:51:15 2016 +0000

    test: Look at Present scaling with number of cpus
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ed83d92b50fcd33a46b20f6a2431206db15d9530
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 16 13:49:24 2016 +0000

    sna/present: Check incoming pitch before flipping
    
    Framebuffers are restricted to pitches with a multiple of 64. Check
    before we flip.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit cd864c005568c68610abb85e4a9453377a460aae
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 16 13:14:40 2016 +0000

    tests: Anticipate Present reporting too early
    
    Given Present bugs, any completion event may be sent too early and
    out-of-order. Make sure we drain all outstanding events before
    continuing on to the next test.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 945d4f7b12047f8e0ecbb5a56865c91d9a691f1f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 16 11:21:16 2016 +0000

    configure: Replace ${} with $() for libtool
    
    One version libtool doesn't like ${} and errors out unless we use $().
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b306dc20e3e92a62f60c4155e18cdcba650b1a62
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 16 11:12:01 2016 +0000

    sna: Relax tiling requirements to cope with kernel errors
    
    If the kernel can't accept our tiling requirements, don't fret until we
    actually need that fence! If we do, then we either stop tiling with the
    buffer or we use another.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e042b5d82558293ef06847f4833efc91a95b5d40
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 16 09:31:20 2016 +0000

    tests: Add DRI2 race against window resize + Composite redirection
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3f56c3d50cc668e51ee649db8191da28bed3c582
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 16 09:39:10 2016 +0000

    sna/dri2: Flush outstanding signals when decoupling inflight events
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4eb2d9dc92cec2053c76df5dc923f5552fd06c9e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 16 08:27:34 2016 +0000

    sna/dri2: Release the dangling chain after decoupling
    
    After releasing the list, we need to mark it as freed.
    
    Oversight from commit a11cbb6954f08edd0d8fb5eeca1debb289fdb9af
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Tue Mar 15 21:11:48 2016 +0000
    
        sna/dri2: Cancel all pending events when the window is resized
    
    which reused the code for destroying the window (where priv->chain will
    not be accessed again afterwards).
    
    Reported-by: Jiri Slaby <jirislaby@gmail.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b6f204b62bbf2d0918761bb7773d2f80fff985fd
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 15 21:24:20 2016 +0000

    sna/dri2: Prevent starting a swap chain for a decoupled Pixmap
    
    When a Window is resized, a new Pixmap is attached to the Window and the
    DRI2 buffers invalidated. However, the client may have requested a swap
    before it is notified of the resize and so we have to discard the stale
    swap. In doing so, we do not want to start a swap chain as it references
    the wrong frontbuffer and causes dire confusion when we start swapping
    for real.
    
    Reported-by: Jiri Slaby <jirislaby@gmail.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=70461#c131
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit a11cbb6954f08edd0d8fb5eeca1debb289fdb9af
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 15 21:11:48 2016 +0000

    sna/dri2: Cancel all pending events when the window is resized
    
    Kill the events early for simplicity.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=70461#c138
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 0d42fce3c684a8ab6f45ad47f6a0dd20a1af0f5a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 15 16:15:02 2016 +0000

    sna/present: Use the current system time when providing a vblank off notify
    
    If we need to report the vblank after the pipe is off, just use the
    current system time rather than the last swap time from the pipe.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit a0bf3c1f48bc77f508f169d3ec8b64aecc902bc2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 15 16:12:56 2016 +0000

    test/present: Catch FPE when notifies are broken
    
    If the Xserver reports 10 frames passed instantaneously, flag an error
    rather than divide by zero.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4e88e7dcc704d89583620af6af2738d49db9e5aa
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 15 21:03:52 2016 +0000

    sna/dri2: Rearrange "impossible" paths to avoid an assert
    
    Ensure that we don't try and double-free the decoupled vblank event by
    checking whether it is still pending first.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3cc011ae11be6437241c3411bce1935ec0b187f5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Mar 14 08:32:15 2016 +0000

    sna: Avoid double-skipping when deleting arrays of CRTCs
    
    When we call xf86CrtcDestroy/xf86OutputDestroy the arrays are shrunk and
    the next pointer is then at the current location, so we need to take a
    step back when iterating over the entire array.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ba85e22c14ed243826d3edf35dd3813d23708d89
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Mar 14 08:26:54 2016 +0000

    sna: When creating CRTC after initialisation, manually create the RR gamma
    
    RRCrtcCreate does not automatically inherit the gamma ramp, but we must
    call RRCrtcGammaGet ourselves instead. Otherwise the ramp is left as 0
    and this will then overwrite our gamma on VT switch (as for whatever
    reason it is reapplied).
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=94465
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 02f67386a3d4046e816ede8c6de4061451696ccf
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Mar 14 08:23:38 2016 +0000

    sna: Set initial gamma_size to 256 when loading from hardware
    
    If the preallocated gamma ramp is not 256 elements in size we replace it
    with a fresh array that is. When doing so, we need to specify the new
    size.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5489402ca1fe17d5b4d20e4dcdc6ac8e6e415b0b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Mar 13 13:28:42 2016 +0000

    sna/present: Add a modicum more debug info
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=94515
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 0204e55b618af285eb31c6eecc3c57b54319a0f4
Author: Ville Syrjälä <ville.syrjala@linux.intel.com>
Date:   Mon Mar 7 09:27:50 2016 +0000

    sna: Restrict reflected rotations to be rotations
    
    After rolling the bits to the left and the right, ensure that only
    rotations remain in the reflection.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d1672806a5222f00dcc2eb24ccddd03f727f71bc
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 24 10:33:22 2016 +0000

    sna/dri2: Add active-scanout tracking to single CRTC flips
    
    When we do a partial flip (one CRTC of many) we install a fake
    frontbuffer for the window. This needs to be included in the
    active-scanout tracking like a normal frontbuffer to avoid being
    recycled too early.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4cd43faa646e368624079b73b216f6546ede5c16
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 23 14:40:39 2016 +0000

    sna: Flush the DRM event queue after a modeset
    
    Changing the mode will cause the DRM events(pageflips, vblanks) to
    be completed and the queue flushed. After applying the CRTC, drain the
    event queue.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3593a2d18928f74ee470f824dc34b8b5b148ce2d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 23 14:36:10 2016 +0000

    sna/dri2: Reset front pointer on frame event across a modeset
    
    If the root window's pixmap is changed (e.g. to resizing the
    framebuffer) then an outstanding flip becomes invalid. The invalid flip
    is marked as having a stale front, and that triggers an assertion if the
    user then tries to schedule flip before the pending flip event is
    processed.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=9425
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 64b1b1f10da59f15a91141c9f76d7d09517f8ea8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 23 09:32:57 2016 +0000

    sna/dri2: Ensure the flipqueue is drained on pageflip failure
    
    If we fail to queue a flip for a CRTC, we attempt to restore the
    original mode. However, if the failure is on a second CRTC, the queued
    flip on the first will still complete causing us to process the event
    twice.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=94250
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 05320318fb940247d8749da8330215d19f41d84e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 18 13:54:11 2016 +0000

    sna: Prefer to avoid direct rendering with FBC
    
    If FBC is enabled, avoid the overhead of tracking rendering into the
    frontbuffer by rendering into a backbuffer and flipping. Again, we have
    no actual flag to indicate when FBC is enabled, so take a guess from the
    module parameter.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b99e8b022c4aaf586ae49e0eb597f0c34bc0e165
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 18 13:53:07 2016 +0000

    sna: Use dirtyfb for fallback direct rendering
    
    The preferred solution when direct rendering is too costly is to render
    into the backbuffer and flip. However, if the user insists, we need to
    tell the kernel when to flush the scanout due to direct rendering.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c4382c5e5b28a60261986b00bf0fcb8da4b78625
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 18 13:51:13 2016 +0000

    sna: Check enable_psr module parameters
    
    Despite protestations over the last 2 years, PSR was enabled by default
    upstream with no way for userspace to detect the change in behaviour.
    Have a look at the module parameter and take a guess.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit aacc3442bb8c280a6ebc1fc1e34451613a72d7c4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 18 10:15:11 2016 +0000

    sna: Restrict set-domain short-circuit to readonly
    
    If we write to the bo, we do want the kernel to mark it as dirty (for
    the purposes of swap invalidation and the like), so we can't apply the
    shortcircuit.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e41040fb55e84fc72612ae503944a99814a5c9d3
Author: Martin Peres <martin.peres@linux.intel.com>
Date:   Fri Feb 12 17:33:24 2016 +0200

    sna_video_sprite: add asserts to catch invalid pipe#
    
    Caught by Klockwork. This will be enough to catch those issues during
    bringup.
    
    Signed-off-by: Martin Peres <martin.peres@linux.intel.com>
    Reviewed-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7c81719b7fcba091fe2e9cf6fb7cb62a13d4f1dd
Author: Martin Peres <martin.peres@linux.intel.com>
Date:   Thu Feb 11 12:19:13 2016 +0200

    display: prevent a NULL pointer dereference in intel_set_scanout_pixmap
    
    Caught by Klockwork.
    
    v2:
     - be less verbose on failure
    
    Signed-off-by: Martin Peres <martin.peres@linux.intel.com>

commit 636b52913cac10e691834a699cff10fb94d395fa
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Feb 13 08:54:04 2016 +0000

    sna: Also mark imported Prime objects as unclean
    
    Since they have an external source, we cannot be sure of their busyness
    or other GPU state and so we need to treat them as unclean.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b2cd809fe2b06325a4572865ec7ca5cfbfcfced2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Feb 13 08:47:29 2016 +0000

    test/dri2-race: Tweak runtimes
    
    When we specify a divider we are looking for slightly different races
    that are in theory not so timing dependent (since we are using vrefresh
    windows). However, since they each take some multiple of vblanks to
    complete, they are much slower. We should be able to reduce the number
    of iterations without losing detection capability.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8f04d6721fe0ac844fa66df3167a779bac236138
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Feb 13 08:46:58 2016 +0000

    sna/dri2: Initialize priv->cache_size
    
    Silence a valgrind warning, though it should have no runtime impace.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 9df8119e1e8216d11a116fdc28c1b499a521ef8b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Feb 13 08:44:15 2016 +0000

    sna: Reorder busyness checks after finding the proxy's parents
    
    Due to the way request tracking on proxies work, we need to inspect the
    parent and not the proxy itself.
    
    Reported-by: Matti Hämäläinen <ccr@tnsp.org>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=94125
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit de7407d20703615c5bf0b1d9f522e93dcc13ba82
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 10 11:00:28 2016 +0000

    test/dri2-race: Add a set of races against Client death
    
    Try terminating the client using XKillClient and seeing if we can find
    any races with Client shutdown.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3aab3684124a77d3dafdfdf1f234b9b68faf7025
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 10 10:50:04 2016 +0000

    test/dri2-race: Use loops for iterating over divisor tests
    
    Expand the test cases slightly to check high dividers everywhere.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8b8c9a36828e90e46ad0755c6861df85f5307fb5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 3 12:37:30 2016 +0000

    sna/gen3: Add missing destination offsets to a few vertex emitters
    
    Sometimes we apply a destination offset (for when the coordinates are
    too large to be automatically offset by the 3D pipeline). Only a few
    paths had forgotten to apply the aforementioned offset.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=93816
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 1c95b7e81140746e2904dbdf7b066937442243d7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 3 09:56:58 2016 +0000

    test/dri2-test: Add WaitMSC accuracy tests
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 65e6bae3ac250cb5f77f9e41498c4aad600fa9b5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 3 09:56:28 2016 +0000

    test: Add present-race
    
    A simple demonstration of what may go wrong when a Window is destroyed
    by another client such as the window-manager.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 84e824873be4172c0ef51744fc9455bb9c12cc9a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 2 11:37:15 2016 +0000

    test/dri2-race: Capture race between window-manger and clients
    
    If the window manager closes the Window before the client disconnects,
    we can end up with a blocked client as dri2 does not call AttendClient()
    in its DRI2DrawableGone.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2bee35a86b77bc7371a81dfa1586398edde56917
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jan 27 11:00:04 2016 +0000

    sna: Restrict TearFree damage discarding to straightforward copies
    
    If we have a rotation, it is beneficial to keep the amount of work we
    need to do to a minimum. So restrict
    
    commit 9a311f9da612ba02b24458f6a40b6a5445ad4869
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Fri Feb 13 14:03:16 2015 +0000
    
        sna: Throw away the TearFree damage if it grows too big
    
    to only apply to TearFree and not if we have active RandR transforms.
    
    Reported-by: Frank Delache <franck.delache@grassvalley.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=93864
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 43fffc8ea93bef012928f077981d9bf7bb7c3023
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jan 27 10:42:47 2016 +0000

    sna: Perform composite rotation on the individual damage elements
    
    As the rotation may need to perform intermediate copies (e.g. displays
    larger than the render pipeline), we can reduce the amount of overdraw
    by using the damage boxes rather than preparing to redraw the entire
    output.
    
    Reported-by: Frank Delache <franck.delache@grassvalley.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=93864
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7817949314a21293c8bc34dec214b42932b19aaf
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jan 27 10:54:46 2016 +0000

    sna/dri2: Avoiding marking a pending-signal on a dead Drawable
    
    If the Drawable is gone, we cannot send it a frame-complete signal, and
    in particular we cannot continue the pending flip-chain.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=93844
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit bb8dc3ef37580a221a40ba3dcbde755edc59bb62
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jan 26 12:50:13 2016 +0000

    sna/video: ValidateGC before use
    
    We required the GC->pCompositeClip in order to apply the current Drawable's
    clip to video region, this requires us to call ValidateGC first.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=93874
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8ab71cd3293ad420b0cdf487e8d5c66170ddc13c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jan 25 21:41:57 2016 +0000

    sna/dri2: Guard signalling swap completion after a FLIP
    
    Before sending the frame swap complete signal after a FLIP, make sure
    the client didn't die in the meantime.
    
    Reported-by: Diego Viola <diego.viola@gmail.com>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=93844
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7bebe12afe549af3eceab35b29415f804949f994
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jan 25 16:03:27 2016 +0000

    sna/damage: Clear all-damaged NULL pointer on destroy
    
    Remember to reset the all-damaged pointer, even if it is NULL.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 21fa92a9ba254527a8661ddde837c7a4c5ff5493
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jan 25 15:37:01 2016 +0000

    sna/damage: Prevent freeing a NULL damage marked as all-damage
    
    After an allocation failure, we may mark a NULL damage pointer as being
    all-damaged. This works on the whole as most places we only ask whether it
    is all or not damaged, and if we do a partial fallback we should just
    then migrate the whole pixmap. However, we tried to destroy the NULL
    damage pointer, and crashed.
    
    Reported-by: Franck Delache <franck.delache@grassvalley.com>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=93720
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b48d4a7917ab793526be47559becc64aacd347ae
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jan 22 20:11:31 2016 +0000

    sna/dri2: Tweak enginement placement on inherited render targets
    
    The main motivation is try and isolate from an upcoming API change in
    busy-ioctl, but is also based on the observation that we now only care
    about write-synchronisation.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 26cc364d2eb078085ff4a6dd2968b426bf333b4f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jan 20 11:06:56 2016 +0000

    sna: Allow for a Y-tiled shadow
    
    If the CRTC can use Y-tiling, why not try it for the shadow allocation
    and perhaps save a composited rotation (still requiring the copy onto the
    shadow)?
    
    Suggestd-by: Ville Syrjälä <ville.syrjala@linux.intel.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3a057beca9f290854dd22cd4d2c0fed01c82dd78
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Tue Jan 12 15:01:04 2016 +0000

    Sync PCI ids with latest kernel, adding SKL GT4
    
    Syncs with:
    
      commit 15620206ae87ba9643ffa6f5ddb5471be7192006
      Author: Mika Kuoppala <mika.kuoppala@linux.intel.com>
      Date:   Fri Nov 6 14:11:16 2015 +0200
    
          drm/i915/skl: Add SKL GT4 PCI IDs
    
    Signed-off-by: Damien Lespiau <damien.lespiau@intel.com>

commit c3dccf76b614d8bcf7fc8b0906754e187a7b7ac4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jan 20 10:52:19 2016 +0000

    sna: Reset CRTC if setting rotation fails
    
    If the kernel doesn't like chaning the native rotation mode with the
    output currently enabled, try disabling it before cryinc foul.
    
    Suggestd-by: Ville Syrjälä <ville.syrjala@linux.intel.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 928050d4e4b0ee958be897d148b60328e9207228
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jan 19 08:49:18 2016 +0000

    sna/dri2: Catch setting signal=true when we have no drawable
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d04e3f63f98eab02614119d59f5df6767bbbf11a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jan 12 09:28:34 2016 +0000

    sna: Setup the GTT domain on the new cursors
    
    We should not rely on first-fault setting the domain for us.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 371219c34a54707a0d568c51defae478079fbf71
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jan 8 09:17:19 2016 +0000

    intel-virtual-output: Virtual heads are numbered from index 1
    
    When checking for VIRTUAL support on the xserver, it helps to check for
    the right name.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 9083d2ed5876f1891727b512da57766d8d11af56
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jan 6 14:09:40 2016 +0000

    intel-virtual-output: Print more helpful error when run on the wrong server
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5c735befdcc40f94bd740be9fc0df54ad53aa174
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jan 6 10:00:19 2016 +0000

    sna/dri2: Ignore pending SwapComplete events when the window is destroyed
    
    Since we need the drawable to call DRI2SwapComplete/DRI2WakeClient, if
    the window is destroyed that becomes inoperable (as we are called late
    in the chain). Let's hope the client isn't blocked.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8e987511f0f190115e2587a94922b766d4f8719a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jan 2 21:29:58 2016 +0000

    tools/intel-virtual-output: Propagate screen blanking
    
    When attaching to a target display, disable the builtin screen blanking
    (equivalent to xset -d :8 s off, or setting
    	Option          "BlankTime"     "0"
    	Option          "StandbyTime"   "0"
    	Option          "SuspendTime"   "0"
    	Option          "OffTime"       "0"
    in the target xorg.conf). Then listen to the ScreenSaver notify events
    on the host and forward the activations/resets to the targets. This
    should then keep all the screen blanking in sync.
    
    Reported-by: Raffael Herzog <herzog@raffael.ch>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=93562
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 082a57e6eb3b364aad681f137364a34988c4af5d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jan 2 21:29:58 2016 +0000

    tools/intel-virtual-output: Respond to expose events on target displays
    
    If the destination screen is exposed (for example screensavers), we need
    to redraw. So enable the ExposeEvent on the target and synthesize
    damage to any clones on that display in order to trigger a redraw.
    
    Reported-by: Raffael Herzog <herzog@raffael.ch>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=93562
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ec92e2584ffa0bf2a7f5bd724b69e68687e11c96
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Dec 20 18:37:38 2015 +0000

    sna: Add fault-injection for cursor ioctls
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2788914ea67fa01b869571f0db61bed2ec964ca2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Dec 30 21:46:37 2015 +0000

    sna: Disable WC mmaps for 945 and older
    
    Unresolved coherency troubles that probably should be fixed in the
    kernel (since the coherency issue is likely wider, but the impact just
    seems to be these old chipsets).
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=90841
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 963b5bb1be874623f06caa421e06cdd2134204dc
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Dec 30 16:12:30 2015 +0000

    sna: Skip sync if we have an idle coherent bo
    
    If we know that our bo is idle and already coherent, skip the call to
    synchronize that bo with the kernel.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 82293901da23d79fd074e5255fda5c95405d52de
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Dec 15 17:56:32 2015 +0000

    sna: Need function definitions as well
    
    Oops, accidentally only commited the function declaration and not the
    function definition for the non-debug path.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f458e8c41112cf56a132ac42cc9e6a4be893ff2c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Dec 15 16:46:47 2015 +0000

    sna: Dump kernel debug messages for KMS failures
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6c4ffba39acb114cbbbfa3359a8c1ba7dfcc7df6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Dec 10 16:19:21 2015 +0000

    sna: Don't disable the native backlight around modesets
    
    The kernel can handle the native 'intel_backlight' automagically around
    modesets, so let it.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c4565979572b61cf7fc0b931333c032c88b259f1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Dec 2 10:06:46 2015 +0000

    sna/dri2: Emit the outstanding signal when eliding a swap
    
    When we do the exchange for the next swap, we should emit any pending
    completion signal for the previous buffer.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit da9ad388a0657b85fcf9a5f78ae1e75d0052dc52
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Nov 26 16:03:07 2015 +0000

    sna: Add DBG for small_copy()
    
    Emit a DBG when we decide that the region is small and pass that hint to
    the backends.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d4aa7ca6f8e554b8de218216fd7e61e4b2df8763
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Nov 19 14:31:11 2015 +0000

    sna: Disable secondary planes on taking over VT
    
    Sometimes the kernel may leave other planes enabled on our VT. So, just
    as we validate that the CRTC state is as we expect when we take over the
    VT, make sure all secondary planes on the CRTCs are also disabled.
    
    Note to self: Xv needs to restore its planes.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 0995ad221d0bab03e4b4f9c1c36849fda2a51339
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Nov 22 17:59:34 2015 +0000

    sna: Remove obsolete assertion
    
    Once upon a time we only flagged th bo->purged when calling madvise and
    being told by the kernel that the bo was truncated. However, we now also
    preemptively set the flag on buffers we decide cannot be CPU mapped,
    invalidating the assertion.
    
    Reported-by: Jiri Slaby <jirislaby@gmail.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=70461#c64

commit f6e9316ed44ff491e26a7f43db71a4883147ca5b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Nov 19 23:20:07 2015 +0000

    Re-enable acceleration!
    
    Double negatives are most confusing before coffee. In removing the
    double negation from the xorg.conf, I inverted the option in the code
    but didn't invert the test. As a result, acceleration was now disabled
    unless you explicitly asked for NoAccel.
    
    Reported-by: Jan Steffens
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c446a7ccc783e3ca00b4b15d017c6e3af66dc646
Author: Wayne Boyer <wayne.boyer@intel.com>
Date:   Wed Nov 18 10:39:42 2015 -0800

    Add Kabylake PCI IDs
    
    Add the Kabylake PCI IDs based on the following kernel patches:
    
    commit d97044b661d0d56b2a2ae9b2b95ab0b359b417dc
    Author: Deepak S <deepak.s@intel.com>
    Date:   Wed Oct 28 12:19:51 2015 -0700
    
        drm/i915/kbl: Add Kabylake PCI ID
    
    commit 8b10c0cf21ec84618d4bf02c73c0543500ece68d
    Author: Deepak S <deepak.s@intel.com>
    Date:   Wed Oct 28 12:21:12 2015 -0700
    
        drm/i915/kbl: Add Kabylake GT4 PCI ID
    
    Cc: Rodrigo Vivi <rodrigo.vivi@intel.com>
    Cc: Chris Wilson <chris@chris-wilson.co.uk>
    Signed-off-by: Wayne Boyer <wayne.boyer@intel.com>
    [ickle: Copy across the real i915_pciids.h from the kernel]

commit 3cdc1780e3fbd789c40487fed4fb2272002784ab
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Nov 19 10:37:42 2015 +0000

    Rename Option "NoAccel" to "Accel"
    
    Totally cribbed from xf86-video-amdgpu/-radeon:
    
    commit 560b7fe6dc66405762020f00e9a05918a36f3a17
    Author: Michel Dänzer <michel.daenzer@amd.com>
    Date:   Wed Nov 11 17:31:34 2015 +0900
    
        Rename Option "NoAccel" to "Accel"
    
    Renaming the option removes the need for a double negation when forcing
    acceleration on and is backwards compatible as the option parser
    automagically handles the 'No' prefix.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 666f25baf00ac3f04096655c4022ec7a2d17247b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Nov 18 11:08:37 2015 +0000

    sna: Only reap the VMA if tiling actually changes
    
    We only need to recreate the GTT mmap iff we need a new fence, so
    preserve the old mmaping when we can.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4ef8dd65e1b533191c234ff8de56e1965a7d58b8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Nov 18 10:59:41 2015 +0000

    sna: Add some DBG around tiling changes
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 745ded3c30f21a4f4c72dc1c86e3d1e105f7339f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Nov 18 10:38:02 2015 +0000

    sna: Remove the VMA from the list when unmapping
    
    If we are forced to drop the vma because the kernel refuses to
    set-tiling on the bo, we also have to remember to remove it from any
    inactive cache list in order to appease assertion sanity checks.
    
    Reported-by: Matti Hämäläinen <ccr@tnsp.org>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 0340718366d7cb168a46930eb7be22f2d88354d8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Nov 13 19:21:37 2015 +0000

    sna/dri2: Don't try and destroy the NULL pointer
    
    From the previous commit, we have to check for NULL before the
    dereference.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2d26643cab33a32847afaf13b50d326d09d58bf7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Nov 13 19:03:36 2015 +0000

    sna/dri2: Drop the reference on the fence when complete
    
    Fixes regression from
    
    commit 8d9e496670f48b4eec64dfe1bcedb49793cf3073
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Wed Jul 22 11:14:01 2015 +0100
    
        sna/dri2: Take over the placeholder vblank
    
    After noting the fence was complete, we would clear it. But I forgot
    that we actually held a reference on to it, and so we would leak the 64k
    batch, and starve the system of available memory in about 18 minutes of
    SwapBuffers.
    
    Reported-by: Arkadiusz Miskiewicz <arekm@maven.pl>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=92911
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c88303a8688b9b0d807b5a31581cb1bde8553966
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Nov 13 18:57:56 2015 +0000

    sna: Limit the allocation retries
    
    If we repeatedly fail to allocate the next batch, just give up.
    
    Reported-by: Arkadiusz Miskiewicz <arekm@maven.pl>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b5c1ceaac3c1114ca260f6a785e5fc8891eb1820
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Nov 13 13:18:01 2015 +0000

    sna: Fix typo when comparing '=' ! '=='
    
    Reported-by: Arkadiusz Miskiewicz <arekm@maven.pl>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7490b9ec263b87b3669096579ec0f0066ec328cb
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Nov 12 09:17:17 2015 +0000

    sna: Wait upon the same ring when out-of-memory
    
    The current out-of-memory allocation code was waiting upon the wrong
    ring id instead of using the index - causing an issue if forced to wait
    upon the BLT ring. If we still cannot allocate, make sure that all
    caches are dropped.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=92911
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e769f9e6ca0b2575f598baf8e2f7dab02a48d6a0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Nov 11 11:00:38 2015 +0000

    sna/video: Avoid dereferencing a masked pointer
    
    First check for the damage-is-all special flag before adding to the
    damage.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c94e653e2e150b74342da566197894b07fc6d4d4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Nov 11 09:04:57 2015 +0000

    sna: Clear the whole tilingv2 struct
    
    The kernel doesn't clear the whole output struct when passed a larger
    than expect struct, so we have to do so ourselves.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 97786e99fbfb8f8ea3931c305f31e993de378fb2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Nov 10 11:29:17 2015 +0000

    sna: Fix Zaphod interaction with DP-MST
    
    When constructing the new DP-MST output name, we only want to reject the
    non-matching ZaphodHead if and only if ZaphodHeads are enabled.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5a18f1fc7e90484729c8e3bb8224658a585998ae
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Nov 10 11:27:55 2015 +0000

    sna/dri2: Flip logic for shadow_wait
    
    Simply sedding the name over to the new variable was insufficient as it
    is now the logical opposite. Fixes
    
    commit 64dbcdd4de1fe1941196265d054272d7d93e5d59
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Tue Nov 10 09:56:07 2015 +0000
    
        sna/dri2: Add a specific recursion indicator for TearFree/DRI2
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 64dbcdd4de1fe1941196265d054272d7d93e5d59
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Nov 10 09:56:07 2015 +0000

    sna/dri2: Add a specific recursion indicator for TearFree/DRI2
    
    Avoid conflating the DRI3/Present flag for controlling TearFree by
    adding a separate flag to indicate when we are waiting inside the
    TearFree shadow handler to avoid recursion in DRI2.
    
    Reported-by: Andreas Reis <andreas.reis@gmail.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=92873
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 47f6c5b211c0458f2bf1e05a736e466bd8b64763
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Nov 10 09:50:43 2015 +0000

    sna: Tweak TearFree interaction with Present flipping
    
    When Present takes over we mark the TearFree shadow as disabled. Before
    Present relinquishes its flip sequence, it copies from its pixmap to the
    screen triggering the shadow wait, even though the screeen Pixmap is not
    current bound (and still marked as disabled). Tweak the conditionals to
    properly skip this wait.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=92873
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit fb0c0adbee3e37d9094bc02354fc3f8c4dc292b8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Nov 9 08:52:38 2015 +0000

    sna: Allow a CPU bo to be read by the GPU as we read from it
    
    Just a minor assertion relaxation to treat a bo as being read by both
    parties as still coherent.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 54b3adc23fbfdc5f6983bca2bcd01de2404911cf
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Nov 8 20:14:50 2015 +0000

    sna: Simply retire-requests
    
    Since we have the ring member available in the request structure, let's
    use it directly rather than attempt a more fragile method of recomputing
    it.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7fc15ec3975e3a99a6bbb869c07172cdee6e5f63
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Nov 8 12:54:09 2015 +0000

    sna/video: Move the composite offsets into the dstRegion
    
    Move the application of the composite offset from the backends into the
    caller so that we correctly apply the offset to the dstRegion prior to
    calling move-to-gpu with that set of boxes.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 694e9bc4e2e9a73ce72b1fb9ef8ecbf773b901fe
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Nov 6 23:28:32 2015 +0000

    sna: Remove bogus assertion from last patch
    
    The dangers of adding seemingly benign assertions at the last moment -
    the assertion is only true for some of the request->bo. Drop it.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b1015d4de0cb040dc47ebfbef1114b65269f6f36
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Nov 6 20:41:03 2015 +0000

    sna/dri2: Protect against a new possible recursion during TearFree
    
    With the introduction of a new SwapEvent that may trigger a copy, we
    need to add another check for recursion from a TearFree flip event.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=92751#c14
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 198246201fe9a07a60b4e1084dcf9ba2e06b5ef5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Nov 6 19:52:24 2015 +0000

    sna: Avoid handing back a cached pinned batch
    
    A few places hold on to the request->bo as a means for checking the
    fence completion. This means that it can have an elevated refcnt and so
    we have to be careful to double check that our cache of batch buffers
    not only are idle, but also not being used by anybody else. For example,
    in the DRI2 code, it can happen that the fence is shared between two
    windows and therefore the second window thinks that it's fence is still
    busy as the first issues a new request touching the old fence.
    
    Reported-by: Jan Kundrát
    Reported-by: Ville Syrjälä <ville.syrjala@linux.intel.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit af680486608686ade375f5737bff556343366230
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Nov 5 16:54:36 2015 +0000

    sna/dri2: Update TearFree recursion prevention
    
    Some time past, we switched to a seperate boolean to mark when the
    shadow is no longer accessible due to recursion - but I missed an
    important check inside the vblank handler.
    
    Reported-by: Joe Peterson <joe@wildlava.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=92751#c5
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 627ef68a8cd7a51627d5b6a98cb0a5bdb1d9b534
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Oct 31 09:27:35 2015 +0000

    sna: Don't extend the display mode cache for an unknown output
    
    When we enable the outputs initially, they only have the desired mode
    inherited from fbcon and have not do a full detect pass. For these we do
    not wish to extend the display mode cache on the output.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 0fa1c696b477d53326bab41d254ffcc8a6fa46f4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Oct 31 09:26:40 2015 +0000

    sna: Add a couple more asserts to catch static requests being queued
    
    The static requests are never meant to be added to the request list, so
    assert that they are not on it.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 94d271b239d358f71ae0bcfcc31422a569d73d41
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Oct 30 18:07:37 2015 +0000

    sna: Allow pipes to be manually assigned to ZaphodHeads
    
    Assigning pipes to a driver instance is hard as not only do we have a
    limited number (so choosing which instances should share CRTCs requires
    user intervention) but also some pipes are limited by hardware to
    certain outputs and certain modes (and we do not have the full knowledge
    of the future configuration to be able to determine where to assign the
    CRTC). As usual, when there is no clear answer, punt it to the user.
    
    This expands the ZaphodHeads option to include an optional
    comma-separated pipe list followed by a colon before the output list,
    e.g.
    
    Section "Device"
            Identifier "Device0"
            Driver "intel"
            Option "ZaphodHeads" "1:LVDS"
            BusID "PCI:0:2:0"
            Screen 0
    EndSection
    
    Section "Device"
            Identifier "Device1"
            Driver "intel"
            Option "ZaphodHeads" "0,2:HDMI1,HDMI2,HDMI3"
            BusID "PCI:0:2:0"
            Screen 1
    EndSection
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d78200e53e6e5b889a71f79c103aa4e1ba148c95
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Oct 30 15:53:06 2015 +0000

    sna: Always refresh the blob property before reading
    
    Ensure that the property value for the EDID is current before
    retreiving the blob.
    
    Reported-by: Rui Tiago Matos <tiagomatos@gmail.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=92728
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 0196fa2da8140853e9542bf41b63cbd345e857be
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Oct 30 15:26:02 2015 +0000

    sna: Handle getblob failures gracefully
    
    As the EDID property blob may be lost at time after we perform the
    detection probe (as the kernel may recreate the EDID blob at any time with
    a new id), presume that if there is no matching property that we can
    simply keep using the last known EDID.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=92728
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit be3748802398a741208715233d36935378ceff58
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Oct 25 15:41:10 2015 +0000

    sna: Always flag the shadow buffer after resetting it fr DPMS on
    
    When switching the outputs back on, we show the current front buffer and
    so for TearFree we always then need to flag the front buffer as active.
    Failing to do so left us rendering straight onto the scanout, defeating
    the notion of TearFree.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=92018
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ef859c807a4bfad7c8a01a1d63f354f3ef310db5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Oct 19 13:07:13 2015 +0100

    sna: Use the new context param for report GTT size
    
    Since get_aperture_ioctl reports the global GTT size and this may
    differ with the per-process GTT size used by execbuffer, query the
    per-process GTT size instead.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3656bcf01e78554aaeafc11ecebb0caf7dd12713
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Oct 19 09:34:43 2015 +0100

    sna: Manually clear the GPU bo needs_flush flag after doing an explicit flush
    
    The kernel often gets confused and fails to flush the bo itself, so lets
    just pretend it worked.
    
    Reported-by: Jiri Slaby <jirislaby@gmail.com>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=70461#c127
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6861391ff34eff423974a73c46cf0b186a6cb335
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Oct 13 12:22:46 2015 +0100

    sna: Make sure that cached upload proxies are marked as all-damaged
    
    It should only be the case that we create the upload proxy in this case,
    but it ensures that the code remains self-consistent if we force the
    all-damage reduction.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6224814b85e8aed75854192ec27aa06163e76d94
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Oct 13 12:20:33 2015 +0100

    sna: Handle proxy objects in undo assertions
    
    Note that we may try to clear a batch containing a proxy object, in
    which case the proxy has a dummy exec entry - so we need to be careful
    in making our assertions.
    
    Reported-by: Laszlo Valko <valko@linux.karinthy.hu>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=92447
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit df72bc57610bb2f58eec9801820ea11628b244eb
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Oct 9 15:40:58 2015 +0100

    sna: Avoid truncating the cursor when scaling up
    
    The affine_blt walks the destination image sampling from the source, so
    we need to walk all the output pixels and not the source size.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5793183c8247b42baa3c4577a3d84d554d589160
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Oct 9 15:17:58 2015 +0100

    sna: Compute rotation cursor transformation
    
    A confusion over the use of marking when we need to compute a
    transformed cursor image using pixman version when we need to compute
    transformed cursor coordinates meant that we failed to compute the
    required transformation after simply rotating the monitor.
    
    Should fix the regression from
    commit bbbcc4101ca01a5c8bec5169e47d703dd742494b
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Fri Sep 18 12:17:07 2015 +0100
    
        sna: Apply cursor hotspot transformation
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>
    References: https://bugs.archlinux.org/task/46606

commit 4e668dd19ca402321091311fc6c2dd5cd9c28f23
Author: Robert Ancell <robert.ancell@canonical.com>
Date:   Fri Oct 2 10:43:10 2015 +0100

    uxa: Add missing const to string to stop compiler warning

commit 096ddef22d6c57198a424eef00845dc7302b0cfe
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Oct 1 09:47:59 2015 +0100

    sna: Indicate when we expect to call RRGetInfo during discovery
    
    Continuing the udevless saga where we query for topology changes on
    calls to RRGetInfo() and so where we cannot call RRGetInfo() ourselves
    on discovering the changes (to facilitate hotplug). The next step is
    explicitly prevent the recursive call.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91929#c10
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 0d3e1d3b2e0d82261e367ebba5992c89c429b7c7
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Tue Sep 29 13:18:58 2015 +0200

    man: Fix discrepancy in man page for ZaphodHeads
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=92179
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 679ee12079a7d2682d41506b81973c7c7d4fa1d8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Sep 27 19:05:26 2015 +0100

    sna: Prevent infinite recursion on udevless RRGetInfo()
    
    As summarised by Mark Kettenis:
    
        Unfortunately commit 2c08d72393e4c8ddf5926571b087459aaa225cb1 that
        was made to resolve this bug introduced infinite recursion if
        polling udev for events fails (which is always the case on systems
        without udev).  The scenario is as follows:
    
        1. The server calls RRGetInfo().
        2. RRGetInfo() calls sna_randr_getinfo()
        3. sna_randr_getinfo() calls sna_uevent_poll(), which returns false
        4. sna_randr_getinfo() calls sna_mode_discover()
        5. sna_mode_discover() calls RRGetInfo()
    
        and we jump straight back to step 2, until we run out of stack
        space and crash
    
    Reported-by: Mark Kettenis <kettenis@openbsd.org>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=91929#c8
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f0fd4d500de03c30c7ce19915f85acadd1ca4e5d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Sep 23 10:52:42 2015 +0100

    sna: Explicitly retire any buffers underneath the static_request
    
    If we are forced to use the static_request (reserved for allocation
    failure), we dispatch the execbuffer synchronously and expect no buffers
    to be present afterwards. Rather than just assert that this is so, we
    should clean up the buffer list!
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 31d42ed5637a1b2223d48d0db4d7c512b27aee07
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Sep 22 10:23:24 2015 +0100

    sna: Check for udev events before reading
    
    When performing RRGetInfo() we drain any pending uevents before checking
    the CRTC/connector statuses. However, some versions of libudev do a
    blocking read and so when we call RRGetInfo() from a Timer callback
    (outside of the usual sigtimer interrupts) that blocking read lasts
    indefinitely.
    
    Reported-by: Sedat Dilek <sedat.dilek@gmail.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7be6263b8207b7b7c4a00acf8e2335b345d3fda7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Sep 18 20:24:29 2015 +0100

    sna: Check alternate userptr mmappings
    
    For a read-only mmaping, we may be able to use a read-write (as we know
    we don't write) if the memory permits us. We can check this by forcing
    the get-user-pages via set-domain(GTT).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit bbbcc4101ca01a5c8bec5169e47d703dd742494b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Sep 18 12:17:07 2015 +0100

    sna: Apply cursor hotspot transformation
    
    After applying scaling to the cursor image, it was being positioned on
    the display incorrectly due to the hotspot transformation remaining
    unscaled and so offseting the cursor slightly.
    
    References: https://bugs.archlinux.org/task/45572
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 15215651a992b7aa06314b9118ad9028b51c7e3e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Sep 16 13:03:20 2015 +0100

    sna: Refresh last detection timestamp on hotplug notifies
    
    If the status hasn't changed, mark the connector as recently probed.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 23986f0a31dbdec2e2086ca898bee43842ab73d4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Sep 13 20:07:35 2015 +0100

    sna: Update the last known status timestamp on modeset
    
    If the modeset is successful we know the connector is still alive, so
    update its timestamp.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 717b6208d0d7bdcdacaf30b871216e6084c7205c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Sep 13 20:06:21 2015 +0100

    sna: Only update the CRTC mode serial number on success
    
    If the kernel doesn't accept the update, then the CRTC remains in its
    previous mode i.e. we should not also touch the modesetting serial
    stamp.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 650da13c7257019728cfca361dfcbe34a6c526ef
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Sep 11 09:02:06 2015 +0100

    sna: Coldplug unknown connections as well
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2c08d72393e4c8ddf5926571b087459aaa225cb1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Sep 10 10:21:00 2015 +0100

    sna: Use RRGetInfo() for setting hotplug/coldplug information
    
    Force the full reprobe, resetting all the output properties on all
    outputs if we detect a status change on hotplug. Rather than simply
    translate the kernel mode lists ourselves, use the common functions in
    case more settings change.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91929
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d50d336605e9be7280529b0eb565402d7646c913
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Sep 9 20:44:42 2015 +0100

    sna: Coldplug all outputs on startup
    
    Since we only update the mode list when the user queries xrandr or upon
    a hotplug event, queue a deferred probe for 2s after X starts in order
    to fill in the unknown modes.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f384af433cbb39ad74e02b10d3700e71c8668506
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Sep 9 20:28:19 2015 +0100

    sna: Hook up kernel modes on hotplug notification
    
    Some display managers, for example mutter, only use
    XRRScreenResourcesCurrent() which means they only query the existing
    modes on an output. We need to therefore update the list of available
    modes after a hotplug event.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f5aabb7bddc6fc5dc910a983d1291c9864f65f06
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Sep 9 11:18:15 2015 +0100

    sna: On hotplug events, update the output->status
    
    During the hotplug event, we query the current connector status and use
    that to trigger an output changed event to the clients. However, since
    we know the new status, we can set that on the RROutput immediately.
    Note the modelist is left unchanged, and will only be queried when the
    user requests it (though we may want to provide that in the hotplug
    notify as well).
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91929#c2
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e179e7d3a436631c434b26fafb0304e777a6b24b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Sep 8 12:57:13 2015 +0100

    sna/dri2: Update the swap_limit on each ScheduleSwap
    
    In order to catch transitions between SwapInterval 0 and 1 in the middle
    of a flip sequence, we need to reset our swap_limit every time.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 300319e2044cb1050e9cbc49c9985b995eaca5fe
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Aug 25 13:47:24 2015 +0100

    intel: Add an Option for disabling native rotation
    
    Just in case we want to debug the native vs software paths and allow
    switching without recompiling.  For the unfortunate
    
    Section "Device"
    	Identifier "igfx"
    	Driver "intel"
    	Option "HWRotation" "off"
    EndSection
    
    default is for us to use HW rotation where available (for speed, reduced
    resource usage and reduce power usage).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3e07681c1948db240b29928bb1e129e559733537
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Aug 22 19:10:47 2015 +0100

    sna/dri2: Stop trying to attach vblank events to pixmaps
    
    Once again I tried to add an event to a pixmap, but only Windows carry
    the CRTC tracking information. Stop it.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit a6317fc3292151b1d02bfb8586f53cf90db4b50e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Aug 22 11:22:44 2015 +0000

    sna: Fix build on squeeze
    
    Not all build enviroments have a definition for the wait ioctl, so
    provide one.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f3e14ec8de1f7c62862d80251c7a11ede0d2dc0e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Aug 22 12:15:15 2015 +0100

    list: Consolidate the two list_for_each_from_safe()
    
    We can use the same macro on top of the xorg list.h interloper as well
    as the private version, so do so.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5daec5173ed273d038bf7aa435f9aac0efba4bc6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Aug 22 11:45:18 2015 +0100

    sna/dri2: Do not attempt to queue an off-screen vblank if the primary is off
    
    Even though the kernel reports and error and we skip the queuing, we
    have information to avoid the roundtrip through the kernel.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 275d8b039a5e2e9937c4015355dddd57a301c028
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Aug 22 11:43:11 2015 +0100

    sna/dri2: Report an error if WaitMSC/GetMSC are called without any CRTCs
    
    On a headless or hosted system, we do not have any CRTC on which to
    report or queue the vblank. Reporting a BadDrawable is evil (as clients
    never expect the error) but is better than crashing the Xserver.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c26cfbcc0c46e05de887ddb750240f16f34029a8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Aug 22 10:28:32 2015 +0100

    sna/dri2: Fix back buffer reuse for simple blits
    
    Along the blit swap path, we expect the buffer to not be scanout
    compatible and not have the same pitch as the front buffer. The reuse
    logic failed to take this into account!
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 78f7451886f0a33df717c57fc1a079ee7e6f221e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Aug 20 10:43:05 2015 +0100

    sna: Check for system memory contents when looking for empty sources
    
    Fixes a regression from
    commit 3f128867d957e30690218404337b00bb327e647b
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Fri Aug 7 15:19:17 2015 +0100
    
        sna: Skip a no-op copy
    
    that forgot that we can flush damage but still have valid contents to
    copy from.
    
    Reported-by: Timo Aaltonen <tjaalton@ubuntu.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 84854419471ebd338ae20d411e44f256be569d1a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Aug 19 23:24:17 2015 +0100

    sna/dri2: Don't queue a vblank delay for a pixmap swap
    
    Otherwise we raise assertions about trying to attach events to an
    illegal Window.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 74c1e45ed5797eca5dec6dcea8f6f734d23d0f89
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Aug 19 21:08:58 2015 +0100

    sna/dri2: Look for potential flip targets when recreating backbuffers
    
    As the window may be reparented during its swap lifetime, we may be able
    to recreate the backbuffer ready for flipping next swap.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3d0cd2dfcac7b855d60c86070a874c6d950466a6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Aug 19 20:27:29 2015 +0100

    sna/dri2: Extend the active buffer tracking to TearFree
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 819971e7a62e695fe4b75af80557b783c8caafd3
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Aug 19 20:24:37 2015 +0100

    sna/dri2: Remove stale active buffer assert
    
    Since the DRI2BufferPtr destruction may be delayed, by the time we do
    free it, the state may no longer be accurate. (At this level at least,
    there is a later assertion to the same regard just as we think we are
    releasing the buffer.)
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6f3e81d430dc80d892d3ffe8b101ff991040237a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Aug 19 19:59:56 2015 +0100

    sna/dri2: Consolidate vblank queueing into a couple of helpers
    
    With the rigamorale of assertions, using the vblank is no longer
    trivial.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e29dc33e3588035ce790e1d534e85a521b2955ce
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Aug 19 18:28:51 2015 +0100

    sna: Release the mode before releasing the accel backend on LeaveVT
    
    When we release the accel backend, we mark the interface as wedged.
    However, when we release the modesetting backend we flush the vblank
    queue which may want to do rendering. So if we do that first then
    disable the accel backend, things we go much smoother.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91658#c20
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6027bfc461c01838577be052d1a76ffc6906e3cc
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Aug 19 16:49:01 2015 +0100

    sna/dri2: Also track the front bo as an active buffer
    
    This so that we permanently exclude the active front buffer from the set
    of triple buffer replacements.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91658
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8a59e85801cb0592eb2d0a074d9254d26a65240f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Aug 19 16:39:11 2015 +0100

    sna/dri2: Initialise scratch.pScreen for copying
    
    Down one particular patch (overlapping render copies) the
    scratch.pScreen is dereferenced (to create a temporary Pixmap). Ensure
    that we populate it before hand.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91658
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8c59c5ba4e368af2ee4a4a811ebf3934de7e4402
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Aug 19 15:20:37 2015 +0100

    sna/dri2: Remove unused local variable in normal builds
    
    The local was only used in debug builds, so remove it to squash the
    compiler warning.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit dab1c0f159d74fc82618b88262e064010e6387ec
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Aug 18 23:27:22 2015 +0100

    sna/dri2: Move the pending swap from the buffer to the event
    
    To ease tracking of the next swap, stash it on the event (which is then
    reused) rather than the back buffer (which changes frequently).
    
    In addition, add debug flags and assertions to track event stages (such
    as making sure we do not decouple/free an event that we have sent a
    signal back to the client).
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91658
    References: https://bugs.freedesktop.org/show_bug.cgi?id=70461
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 18e484502727f2e2e16138a3de5b6727f3879a2b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Aug 18 12:40:39 2015 +0100

    sna/dri2: Transfer the pending back to the new back following the xchg
    
    Third time lucky at getting the pending copy swap with the real back
    correct?
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=70461
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b86974ffd435b2339cd873131e0f90aedc9c4a42
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Aug 18 11:36:46 2015 +0100

    sna/dri2: Do full exchanges of back/pending around deferred swaps
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91658
    References: https://bugs.freedesktop.org/show_bug.cgi?id=70461
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 79fc9a923cdfa4218868f4c371ca80fd40f41253
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Aug 18 09:21:20 2015 +0100

    sna/dri2: Immediately complete a stale swap if any are queued
    
    If we don't control the vblank for the window, we cannot use the vblank
    signal as it ends up being queued as well.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91658
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 07eee812b2047642c76190d043ee4aa4ce338c64
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Aug 17 20:38:57 2015 +0100

    sna/dri2: Avoid pushing the triple buffer into the cache list twice
    
    A side effect of commit 4cea8037984c3d5e171be22710384f66660ca4c6
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Sat Aug 8 22:10:20 2015 +0100
    
        sna/dri2: Restore caching of fullscreen triple buffers
    
    was that we discovered that we had been inserting the buffer into the
    cache list multiple times.
    
    Reported-by: Dan Doel <dan.doel@gmail.com>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91658#c5
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 1b3cf1efe3c091f5c4c519c81381475fb2587383
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Aug 17 12:45:24 2015 +0100

    sna/dri2: Check that the copy succeeds before associating the request
    
    If the DRI2 copy ends up on the CPU, then we will not have a GPU
    request for the operation.
    
    Reported-by: Zdenek Kabelac <zkabelac@redhat.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 9b0ed16385ae076c262a2e09639822d9488ccf57
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Aug 16 13:31:16 2015 +0100

    sna/dri2: Flush the pending flip when a client disappears
    
    If a client dies with a pending flip, we have to complete it so that the
    scanout matches the frontbuffer again. This requires one last flip
    following the client disapparance.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 521b2c5a3b29a399b4b32b027eeb097accd4b3dd
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 14 18:49:43 2015 +0100

    sna/dri2: Use the primary CRTC for swap completion for offscreen Windows
    
    Letting GL clients run amok when offscreen (or when hidden) has
    unexpected UX behaviour. Instead we can elect to throttle them to the
    nearest CRTC and keep the desktop running smoothly.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2c035991668b15304614f97b94a0bf58442d8b58
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 14 10:40:17 2015 +0100

    sna: Fixup conversion of rotation into reflection
    
    Similarly to the fix for reflection into rotation, make sure we only set
    one Rotation bit afterwards.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit eea91b8e234083b4526a969a5edc0284e3fb482b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 14 10:29:56 2015 +0100

    sna: Only handle a rotation natively if all bits are supported
    
    Since we can combine Reflections and Rotations, we have to check all
    bits.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f75a5689c38ee1f41f98ac520d0b3dd1ee92755d
Author: Bob Paauwe <bob.j.paauwe@intel.com>
Date:   Thu Aug 13 16:51:37 2015 -0700

    sna: Fix the reduction of xy reflection onto rotations.
    
    When reducing a xy reflection to a 180 degree rotation, make sure
    only one rotation bit is set.  Also by rotating the bit left, we
    can support cases where xy reflection happens with 90/270 degree
    rotation.
    
    Signed-off-by: Bob Paauwe <bob.j.paauwe@intel.com>
    [ickle: Interleave comments]
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 656c0a6946f3bd99ee89486d34bcde8d09af2307
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Aug 12 12:31:27 2015 +0100

    list: Add missing ';' for the compatiblity macro for intermediate xorg
    
    Reported-by: Joakim Tjernlund <joakim.tjernlund@transmode.se>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5a9a3e73a9252cffbaf5f361e98c096095725a64
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Aug 11 10:48:48 2015 +0100

    sna/dri2: Keep the most-recent back buffer cache when reaping on idle
    
    When the client misses a swap, we consider it idle and unlikely to swap
    again for a while. We try to take advantage of that and remove the old
    back buffers. But it is likely to swap again and so having some of that
    cache around would be advantageous.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4cea8037984c3d5e171be22710384f66660ca4c6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Aug 8 22:10:20 2015 +0100

    sna/dri2: Restore caching of fullscreen triple buffers
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit fd5f44f4d27e7a28221ea9755664a6da6dd14cd8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Aug 8 22:09:53 2015 +0100

    sna: A couple more asserts for valid flip data and handling
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit cadea260de76a398f9141b18ae91d1646e9a305e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Aug 8 15:39:05 2015 +0100

    sna/dri2: Add the old buffer from a chain swap to the swap cache
    
    Rather than just discarding the old buffer, we want to add it to the swap
    cache and so hand it back to the client in the near future.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 611ec7d7d476c47eefc35e2857bc6b87af819e43
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 17:19:25 2015 +0100

    sna: Remove incorrect assertion
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f324506f7da369222b6c5dd65dfddaea65b7cb41
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 16:44:19 2015 +0100

    sna: Prefer direct writes if the target is LLC
    
    If we can use WB CPU writes into the target, prefer to do so.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 095528e6c3ca6aba2b141f451d0e1f14f3e57a59
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 16:29:54 2015 +0100

    sna: Tweak the semantics for small uploads into Damage tracked pixmaps
    
    Based on further study of behaviour under a compositing manager, always
    prefer to upload directly into the flushed bo, with a couple of
    exceptions.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 07bcd3f0c715a37ac24a630173e0e28056567421
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 15:26:30 2015 +0100

    sna: Use direct uploads into a Damage tracked for v.small operations
    
    If the batch is being frequently flushed due to Damage+Composite
    tracking, we cannot amalgamate the small copies into the destination and
    so end up sending thousands and thousands of tiny batches with tiny
    render copies hogging the GPU.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91577
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3f128867d957e30690218404337b00bb327e647b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 15:19:17 2015 +0100

    sna: Skip a no-op copy
    
    If the source has no contents, the destination is equally undefined.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit a3ac461a302498335fc7b03ec3a59e9a2fd61a75
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 15:18:49 2015 +0100

    sna: Add a handle=%d to a DBG for consistency
    
    Helps with grepping if the DBG are consistent.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5ef9d68043dac2628695b145846e724c2fa98abc
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 14:04:31 2015 +0100

    sna: More simple DBG tracing around cleanup/retire handling
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit fd0236bb8e2e15665d72b8eb7f5ff15571a5c60b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 13:48:38 2015 +0100

    sna: Release the reference on the rq->bo during forced cleanup
    
    Since the switch to preallocating the batch buffer, the request owns its
    reference to the rq->bo. However, dropping that reference was missed
    during the cleanup.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6bab82b91d64af2e31d9f5fe7705c68caf09004b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 13:25:14 2015 +0100

    sna: Always prefer a fresh allocation for the batch if !llc
    
    An unwanted subtle change in preference from
    
    commit 8c465d0fbf84b1d29c54d620f09063d2b7ccfeb8
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Fri Aug 7 10:15:42 2015 +0100
    
        sna: Fallback after a bo allocation failure for the batch
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit a00fdce1fdf21379887511e7d4247ca401dc3a77
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 13:24:13 2015 +0100

    sna: Add a little more DBG information to kgem_retire()
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d78685787a595ca68aec08074744fa23ed4f3d93
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 12:59:57 2015 +0100

    sna: Fix sync'ing to the most recent request on forced cache cleanup
    
    We picked the oldest, not most recent and so were not recovering as much
    memory as desired.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 862c0d3cc9634923f4c6db987c658164e6de50da
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 12:57:31 2015 +0100

    sna/dri2: Make event chaining DBG clearer
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f1b1baa7ffe55a78537160d8b679ce0225f06d63
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 12:45:26 2015 +0100

    sna: Add a DBG for when we discard an invalid old mmapping
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 672436efd5b69fb9007cb80804a351b1e1572b60
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 12:03:34 2015 +0100

    sna: Treat being wedged as unlikely during rendering with HW
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ccc553ff034534233f08ce306d4c4911059337c6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 12:01:38 2015 +0100

    sna: Stop allocating requests once wedged
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b0f125495caced05548442bc2fe64a4b1b46339c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 11:57:27 2015 +0100

    sna: Tweak DBG traces for cache cleanup
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 90b6cba0669b296ff21ff7b4410a7a0515ee2489
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 11:07:09 2015 +0100

    sna: Add DBG trace when doing a forced cache cleanup
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ca71199679cac9cc161c84cb09d12f133abf8a64
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 10:40:30 2015 +0100

    sna: Harden batch allocation against resource starvation
    
    If the batch allocation fails, retire the oldest request and try again.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91577
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8c465d0fbf84b1d29c54d620f09063d2b7ccfeb8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 10:15:42 2015 +0100

    sna: Fallback after a bo allocation failure for the batch
    
    If we fail to allocate the next bo to use for the next_request, we can
    just fallback to the delayed allocation used by !llc.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=91577
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 69d8edc11173df021aa2e158b2530257113141fd
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Aug 7 10:08:17 2015 +0100

    sna: Handle batch allocation failure
    
    Whilst we currently do not try and submit a failed batch buffer
    allocation, we still treat it as a valid request. This explodes much
    later when we inspect the NULL rq->bo.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91577
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit bc063c9f4af90542297877281b1b9f4692dafde4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jul 31 17:17:26 2015 +0100

    sna: Undo a CRTC flip that results in a pageflip failure
    
    If the pageflip following the CRTC fixup fails, we can be left with the
    flip-to bo being left as the CRTC scanout. If that is so, reset the
    desired mode (and original scanout bo).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 9451976a5b00416a1247cb5b80c4943b613e56eb
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jul 31 17:14:12 2015 +0100

    sna: Assert that flip handler/data exists before invoking
    
    Just an explanatory assert in case we ever jump off into a NULL function
    pointer.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6a2dcb388e6b549c3175ccfbcd3f1751e25de40a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jul 31 10:40:32 2015 +0100

    intel: Refactor i915.ko loading support
    
    Different OS name the i915 KMS module differently, so make it convenient
    for us to be able to feed in the right name, or even just try them all
    and pick the first one that exists!
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4246c63347290390a2104739c719f5ff6a05a0e2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jul 29 09:42:26 2015 +0100

    sna: Fix off by one in constructing XCopyPlane on bdw
    
    Broadwell expanded all the relocations and we needed to adjust our
    command construction to match. I missed offsetting the XY_SRC_COPY_IMM
    used for XCopyPlane resulting in garbage for small copies on Broadwell.
    
    Reported-by: Omar Sandoval
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=91499
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 66e16d97ee29595922cd7e38f172ffcc4b87724e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jul 29 08:58:44 2015 +0100

    test: Exercise copyplane
    
    Reported-by: Omar Sandoval
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91499
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4f0a58c9db4d1ac32a79c87392454ad859912f47
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jul 28 13:49:55 2015 +0100

    sna: Batch process hotplug events
    
    Read all available HOTPLUG uevents and batch them into a single topology
    probe. Like waiting for a bus, when one hotplug uevent arrives expect a
    few more.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6be2bea5f02d6155da7862e247b5d3b8935b6892
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Jul 26 19:58:53 2015 +0100

    sna: Double check for Present takeover before TearFree flips
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91467#c17
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d11dc75fb5a95ba410fedd86d9e1dd50260af979
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Jul 26 19:07:45 2015 +0100

    sna: Only check non-NULL Pixmaps
    
    check_pixmap() can be called very early in the Window setup proceeding,
    before a pixmap is even assigned to a Window. There we expect the Window
    to be NULL, so be more careful in our check_pixmap.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=91467#c16
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e5f8f90f686879950766babbe805cd9d2412aca3
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Jul 26 19:03:46 2015 +0100

    sna: Stall for outstanding TearFree flips when taking over with Present
    
    When juggling Present and TearFree, we have to hide the extra flips from
    Present as it cannot account for them. Preferrably we want to schedule
    the Present flip following completion of the TearFree flip, but for the
    moment simply block and wait until TearFree completes before starting
    Present.
    
    Reported-by: Andreas Reis <andreas.reis@gmail.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=91467
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7e5e006be496f338337ac9baea9be5fa5fbd8fd0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Jul 26 18:40:41 2015 +0100

    sna: Add a few more DBG and assertions around Present/TearFree interactions
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91467#c12
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 50f3e9c41c6de98f917a9ddc78aabdda421f920a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Jul 26 18:22:16 2015 +0100

    sna: Add a small pixmap sanity check
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f7cb248169a2b824caca5186e0f0aaf336d9d5ed
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Jul 26 17:45:30 2015 +0100

    sna: Add a some DBG info to Window creation/destruction
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c7d0acf78521d90cfbf087bff108d7c3807a79d2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Jul 26 16:46:03 2015 +0100

    sna: Add a DBG trace to reusing pixmap headers
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91467#c9
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit bff0272b4fbd0e786f77a0f5a9e4ad1eb6df893e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jul 25 11:54:04 2015 +0100

    sna: Put the assert(!kgem->can_fence) back to where they were
    
    Still need to improve the handling of set_gpu_tiling() to mark up the
    unfenceable buffers better, but we can't more the asserts here as we
    don't have the kgem struct available.
    
    Fixes 2f1623daed94b98d3bae3c9ee8346e8de9afc33d with asserts enabled
    
    Reported-by: Sedat Dilek <sedat.dilek@gmail.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8090a65e2df522e54bf9e4d63dc6ab1ceee19910
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jul 24 12:16:02 2015 +0100

    sna: Only reset the bo->needs_flush flag if the buffer is busy-write
    
    Since the kernel now differentiates whether the buffer is busy for
    read/write, we can use that knowledge to better set our own
    bo->needs_flush flag only when there are outstanding writes to the
    buffer.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4cc2fb8fbfa09699abfa10d563b28fdac197af99
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jul 24 11:39:53 2015 +0100

    sna: Add logging for set-tiling failure
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f252dba9da4faaeb6b6822090adc867a707d517d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jul 24 11:34:25 2015 +0100

    sna: Use DBG_NO_TILING to disable all fencing
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ad20fd401b8c3ca128bd0fcf5a71ba90beda9d70
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jul 24 11:30:46 2015 +0100

    sna: Ensure that DRI2 buffers are created with a fence
    
    We use the fence as a backchannel to commuicated the tiling mode to the
    DRI2 client, so in such cases we cannot tolerate a failure to set the
    tiling mode.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=70461#c114
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2050d03f520a5027450b65c2617ab02a92287d23
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jul 23 14:01:34 2015 +0100

    Start splitting out the benchmarks from test/
    
    First comes the swap overhead measurement for various window modes.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit a29e765ec0c1d73ee7ef2dad3aa148214ec04335
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jul 22 11:34:51 2015 +0100

    sna: Fix the last character before a colon in the fake-edid paths
    
    I chopped off one too many characters when creating the path in the
    presence of a colon-delimited list.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8d9e496670f48b4eec64dfe1bcedb49793cf3073
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jul 22 11:14:01 2015 +0100

    sna/dri2: Take over the placeholder vblank
    
    If we are doing synchronous but immediate swaps, we may notice that we
    have a vblank placeholder from the last swap. If so, we can replace it
    with the swap we need to perform on the next vblank.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7301516b63d2e5fcd594f1e50a0f7b3b9bb5cadb
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jul 21 14:09:01 2015 +0100

    tools/cursor: Error on malloc failure
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 18b947b99919e7a1b8a80eda47fa29bf8675bc69
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jul 21 14:05:40 2015 +0100

    sna: Abort output construction on allocation failure
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6742fea212628ae7c9acbbc58b46bd32e2927722
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jul 21 13:52:23 2015 +0100

    sna: Terminate the fake-edid path correctly
    
    An off-by-one on the NUL terminator placed it after the path string.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2cd7cb9e93767d8492bd4a72a973b18184730322
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jul 18 11:56:57 2015 +0100

    sna: Allow user override of EDID for an output
    
    As a slightly more convenient approach than loading the EDID on the
    kernel command line, allow the user to specify the EDID path in the
    Device section of xorg.conf, e.g.
    
    Section "Device"
    	Identifier "igfx"
    	Option "CustomEDID" "DP1:/path/to/dp1.edid,DP2:/path/to/dp2.edid"
    EndSection
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=89945

commit 57725564179b8ddb48d5c9437fde91a6c02c0740
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jul 16 19:10:29 2015 +0100

    sna/dri2: Fix vblank keepalive signalling
    
    When emitting the keepalive, it helps to actually request the signal
    from the kernel.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6d3802972886be426fe00f3abf2eedba4f6cb393
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jul 16 14:31:50 2015 +0100

    sna: Block cursor signals during modeset
    
    Modesetting can be slow, and we certainly don't want to have to keep
    restarting it due to an interrupt from an invisible cursor.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6f4a14303298e4c86080b76993bc15a0188679ae
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jul 16 10:30:10 2015 +0100

    sna: Stop trying to CPU mmap a prime object after failure
    
    If we fail to CPU mmap an object, mark it as inaccessible and never try
    again. The likely scenario is that is it a PRIME object not backed by
    our shmemfs storage and so unmappable.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b549b4fd38cd23623dec7fdb9800e590a9b37c0b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jul 16 10:16:07 2015 +0100

    sna: Add a DBG option to control native rotations for testing
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2c5063938cc809f624e56efd4673041fa8141e81
Author: Martin Peres <martin.peres@linux.intel.com>
Date:   Thu Jul 9 11:26:38 2015 +0300

    uxa: fix the call to PixmapSyncDirtyHelper, broken by xserver's 90db5ed
    
    [ickle: switch to HAS_DIRTYTRACKING_ROTATION as suggested by Dave Airlie]
    Signed-off-by: Martin Peres <martin.peres@linux.intel.com>

commit 15d8b06d546c651300c0ee649673f15e0731715c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jul 10 10:02:32 2015 +0100

    sna: Prevent a crash from an invalid EDID read
    
    Suppose that the kernel reported a truncated EDID, we will eventually
    crash by trying to access invalid memory. Prevent the crash by fixing up
    the EDID header to fit the size read from the kernel (though we don't
    fixup the checksum, so strict conformance tests will still complain, but
    we won't crash.)
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e5c6e48cc9e11f659d0d9d1b907357e28a554e9f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Jun 28 18:25:37 2015 +0100

    sna/dri2: Discard backbuffer cache on Window resize
    
    After the Window resizes, we should never hand back a buffer of the old
    size or else we end up rendering garbage - with the possibilty of GPU
    hangs or memory corruption.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=91036
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 41f401ae27ee753d66aae341be60b27167bc5b62
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 27 20:24:45 2015 +0100

    sna/dri2: Early return for empty DRI2CopyRegion
    
    It's possible if the Window is redirected whilst the client render for
    its backbuffer to no longer overlap with the visible Window. In this
    case, we attempt to copy an empty region, but it debugging is enabled
    this throws an assert.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=91120
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6fc7b16b931946995ffab99c5216810417cfeb99
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jun 25 17:08:59 2015 +0100

    sna/dri2: Remove overzealous assertion
    
    sna_dri2_xchg() is also called on the flip path to do an immediate swap
    of a hidden buffer, in which case can_xchg() returns false as it
    believes that the swap requires a flip.
    
    Reported-by: Jiri Slaby <jirislaby@gmail.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=70461#c109
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f97c6ba9dcb4488615a8f8cc7ad5790cc61f5a9e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jun 25 11:47:25 2015 +0100

    sna/dri2: Track original allocated size for copies
    
    When we record the next scanout for display after the following vblank,
    note the size of the allocation as well as its name and bo et al.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=70461#c105
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 990499c6d98306b4eafeb6405ed209988da301a6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jun 24 14:36:32 2015 +0100

    sna/gen3: Allow gen3 to use smaller vbo if already available in cache
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f414ed4e40292e91e9c6850fb01a26334e6b43c7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jun 24 11:02:28 2015 +0100

    sna: Fix misspelling of "caching"
    
    Apply s/cacheing/caching/ because I am alone in my belief of how to
    spell cacheing correctly :)
    
    Suggested-by: Sedat Dilek <sedat.dilek@gmail.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2d263ff7e662bdedf685d4dbcf7cd1bfbf241395
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jun 24 10:19:26 2015 +0100

    sna/gen4: Fix larger than 3D pipeline fills
    
    If we need to handle a FillRectangles request that is larger than the 3D
    pipeline can handle, we need to split that operation up into smaller
    chunks. This is achieved by redirecting the rendering through a view of
    the surface (offset so that coordinates are within range), or else we
    have to fallback to creating temporary surfaces.
    
    If we fail to do so, we should hit an assertion that the render target
    fits within the 3D pipeline inside gen4_emit_drawing_rectangle()
    
    Reported-by: Zdenek Kabelac <zdenek.kabelac@gmail.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 293450a23ddbc7beafb786b24ce7981af84330b1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jun 23 17:54:36 2015 +0100

    sna/dri2: Rearrange proxy tracking for single-CRTC flipping
    
    Looks like amalgamating the per-CRTC xchg with the blit caused a few
    regressions with TearFree single monitor flipping.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=91066
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ac2aee9f5a54c6fa8e48b512905a5fe84cbba204
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jun 22 14:36:35 2015 +0100

    sna/dri2: Rearrange assert to avoid false-positive
    
    One assert(active_scanout) was firing when feed in an old flip bo, which
    in hindsight was quite expected.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 87b5ca2c3ed45a46ac037e71e96922b1a7f8c10f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 19 15:59:01 2015 +0100

    sna/dri2: Stop leaking the cache entry when unable to reuse the old backbuffer
    
    If we cannot cache the current backbuffer, due to either it not fitting
    or because a reference to it still exists, delete the cache entry we
    were holding for it - or else we slowly leak the cache list and
    gradually get slower and slower walking along the growing chain.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit fa1b4058985783f2a2f2d59a6f0d76266bba22d1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 19 15:31:44 2015 +0100

    sna/dri2: Add a bit of paranoia required for a wedged GPU
    
    We can fail to submit the batch if the GPU is wedged (or the driver
    upset), in which case the bo will be NULL and we should not blindly
    dereference it.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b24e7581bd1e5a0215cb73ec87093ebf03c20278
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jun 17 17:55:04 2015 +0100

    backlight: Factor known names into preferred interfaces
    
    Since the /sys/device/backlight never turned up we face an issue with
    disambiguating the backlight on multi-GPU devices. Both intel_backlight
    and nv_backlight are presented are raw interfaces, and on modern systems
    the ACPI interface is defunct, so we need a way to distinguish them. So,
    we fallback to our priority table of known interfaces and rank them
    accordingly, first by class (platform, native, raw) and then by priority.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f1f2e7202854c725293c63293de1552337c717b2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jun 16 16:45:59 2015 +0100

    sna/dri2: Handle intermixing of exchanges and blits
    
    Since there were two paths performing similar tasks for swapping a
    windowed buffer, they would get easily confused and queue themselves in
    conflict with each other as they behaved slightly differently wrt to rapid
    swaps. Almagamate the two paths such that the behaviour is the same -
    with the complication being in tracking the spare active buffer.
    
    Fixes (some at least!) flickering from
    commit 72d208a7f2f0e8f2d93483e535154f34a8a26d81
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Thu Mar 5 12:26:15 2015 +0000
    
        sna/dri2: Perform swap elision on windows for swap-interval==0
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7d9a74622e5a936e4860fcef8358619bf59adae8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jun 15 14:16:34 2015 +0100

    sna: Be robust in handling DPMS failures
    
    If we fail to turn off an output via DPMS, disable the entire CRTC in
    order to blank the output and save the screeen/power.
    
    Reported-by: Lukas Hejtmanek  <xhejtman@fi.muni.cz>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=90179
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 670d05f438520bcef8e86a0e32016ae542c61cee
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 13 18:43:13 2015 +0100

    sna/dri2: Destroy the right bo
    
    Fixes copy'n'paste error in
    
    commit d46c793663d2b1b5ffb923500111b7affa8402b6
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Fri Jun 12 13:50:35 2015 +0100
    
        sna/dri2: Remove the active_scanout flag when deleting the event
    
    Reported-by: Andreas Reis <andreas.reis@gmail.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=90968#c8
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ed7bcae0ab0af41bc51dbcb729e4af34e2ba5094
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 13 12:53:19 2015 +0100

    sna/dri2: SWAP_THROTTLE is also used for a delayed SWAP
    
    If there is already a pending operation on the drawable, the swap is
    queued. It is queued with SWAP_THROTTLE which classes with the
    vblank_mode=0 chaining, so the choice is to either review all other uses
    of SWAP_THROTTLE and duplicate the chain swap handling, or to choose when
    use to the alternate copy or back buffer. This patch opts for the
    latter.
    
    Fixes regression from
    commit dcb4d323ca19f86fbe0230378ac9035161a70f9e
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Thu Jun 11 13:54:49 2015 +0100
    
        sna/dri2: Mark the pending backbuffer copy as active
    
    Reported-by: Christoph Haag <haagch@frickel.club>
    Reported-by: Andreas Reis <andreas.reis@gmail.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=90968
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7e965a45d1bb3d39ddb9c62dde536d0d66e92537
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 13 09:30:05 2015 +0100

    sna/dri2: Extend keepalives out to 100ms
    
    Keep the swap cache around for 100ms, so only if the app drops below
    10fps do we start having to recreate buffers on the fly.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit a0af3d1856e51848ce411daa1d4e87bacc274f7f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 13 09:29:12 2015 +0100

    sna/dri2: Extend keepalives to windowed swaps
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 92a27732217b4d70f9af7d3dc12de7d69d5a6ab6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 12 14:29:42 2015 +0100

    sna/dri2: Record fence bo by inspecting the dst_bo
    
    As the backend may submit the batch as it completes the copy, we need to
    look at what request the dst_bo is in rather than assuming it is the
    next_request.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit dc9ee01d1255faad81f7667b99b4871e5f08d8c7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 12 14:26:56 2015 +0100

    sna/dri2: Correct a couple of DBG statements for copy_region
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d46c793663d2b1b5ffb923500111b7affa8402b6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 12 13:50:35 2015 +0100

    sna/dri2: Remove the active_scanout flag when deleting the event
    
    If we cancel the event, make sure we remove active_scanout marker.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4c17a20a71d94de392a7ca068ca01c755da8e74d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 12 13:44:41 2015 +0100

    sna/dri2: Keep the async swap event alive until the copy is complete
    
    Although we are ordered wrt to the client, there is no point allowing
    the client to continue submitting rendering and eventually blocking
    whilst we are still waiting for the previous frame to be shown.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit fc137ae504b31a238e64bc1a5d19c41b2074c60a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 12 13:24:10 2015 +0100

    sna/dri2: Avoid touching shared gpu_bo->flush between dri2/dri3
    
    Not only is the pixmap->flush flag shared, but so is the lower level
    gpu_bo->flush flag, so further to
    
    commit 19d1e4ee19a93905d8d2496f856a18eb07bc23d6
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Thu Jun 11 13:43:10 2015 +0100
    
        sna/dri2: Be wary of interactions with DRI3 and sna_pixmap->flush
    
    we need to be more careful when asserting the state of gpu_bo->flush
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b6a635baf3a2aefd8ae613ba9046222ba7911dfa
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 12 12:46:38 2015 +0100

    sna/dri2: Move the backbuffer cache from the event chain to the window
    
    We still only keep it alive whilst the event chain is in progress, but
    moving the cache onto the window allows us to reuse it easily for triple
    buffer window swaps as well as full screen flips.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit a00d9999f410b3ad5bb05ed68b7dd4e7166fd868
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 12 10:33:17 2015 +0100

    sna: Fix tiling trapezoids
    
    When the trapezoid is rendering to a surface larger than the 3D pipe can
    handle, we split it into tiles. However, the code to do so insisted on
    passing along the wrong pointer and consequently crashed.
    
    Based on the patch by Carl Michal.
    
    Reported-by: Carl Michal <michal@physics.ubc.ca>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=90940
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit dcb4d323ca19f86fbe0230378ac9035161a70f9e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jun 11 13:54:49 2015 +0100

    sna/dri2: Mark the pending backbuffer copy as active
    
    In order to perform swap elision for windows, we defer the blit until
    the next vblank and then do whatever was the last buffer to be presented
    by the client. Whilst that copy is pending, in the same manner as a
    pending flip, we cannot hand that buffer back to the client for use (or
    else they will render over top of it before we copy from it, or even
    worse we copy from it in the middle of rendering).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 19d1e4ee19a93905d8d2496f856a18eb07bc23d6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jun 11 13:43:10 2015 +0100

    sna/dri2: Be wary of interactions with DRI3 and sna_pixmap->flush
    
    Since both DRI2 and DRI3 manipulate the sna_pixmap->flush flag, we have
    to relaxation assertions that it is wholly owned by DRI2.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f71148a8b792ba917a007dfc5b06bb592b1963eb
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jun 11 13:05:43 2015 +0100

    sna/present: Downgrade a known assert failure to a warning
    
    We know Present is sending garbage msc into the wait_vblank, so just
    warn about the error so that we do not prevent usage of --enable-debug
    due to somebody else's bug.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6651a03e627d5ad0f96a0da07b598b9cb8945793
Author: Damien Lespiau <damien.lespiau@intel.com>
Date:   Thu Jun 11 10:06:45 2015 +0100

    Add Broxton PCI ids
    
    Syncs up to
    
    kernel commit ee87697f8bc4da0aea6fe1a825c734fb5e4a5b3b
    Author: Damien Lespiau <damien.lespiau@intel.com>
    Date:   Fri May 15 19:43:56 2015 +0100
    
        drm/i915/bxt: Update the Broxton PCI ids
    
    and, importantly, including
    
    kernel commit 1347f5b46a270db1991625f9f57af91e23a4b512
    Author: Damien Lespiau <damien.lespiau@intel.com>
    Date:   Tue Mar 17 11:39:27 2015 +0200
    
        drm/i915/bxt: Add BXT PCI id
    
    Signed-off-by: Damien Lespiau <damien.lespiau@intel.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4c0d0f4d38c8e1cb94ea5f02759ec94fdc6a8267
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jun 10 17:56:51 2015 +0100

    sna: Increase assertion to cater for concurrent & recursion vblank/flip handlers
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 76be8782729052904a0a7222b1b66569636523a6
Author: Sedat Dilek <sedat.dilek@gmail.com>
Date:   Tue Jun 9 21:14:35 2015 +0200

    Fix typos found with codespell v1.7
    
    To get codespell v1.7 check [2].
    
    [1] https://github.com/lucasdemarchi/codespell
    [2] https://github.com/lucasdemarchi/codespell/releases
    
    Signed-off-by: Sedat Dilek <sedat.dilek@gmail.com>

commit 5f626e124142bd8968a031451c38967ca5de2f7c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jun 9 08:36:22 2015 +0100

    sna: Pass scanout flag when creating PRIME bo
    
    For PRIME bo, we need to use uncached render targets so that any writes
    are flushed out to main memory where they can be immediately read by a
    PCI device. For simplicity, we just request that PRIME bo be also
    SCANOUTs as that ensures that they will be created with the right
    attributes for coherent main memory.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7fba4aa54d8efb65cb04b88f930e8b5301176770
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jun 9 08:31:29 2015 +0100

    sna: Flush SlavePixmap dirty rects before calling ProcessPending
    
    As the slave may use the ProcessPending damage callback to do its own
    copying, we need to flush before.
    
    Reported-by: Dave Airlie <airlied@redhat.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 46d74edf991f315319236ba81c6e357e0cb0dddc
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 5 17:43:22 2015 +0100

    sna: Only add the COW to the flush write if exported for writing
    
    If the source is only being exported for reading, we can skip adding it
    to the flush list only to perform a no-op.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ada30742ec115a44445e24c1775583b2684d94a4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 5 16:44:18 2015 +0100

    sna: Add COW source pixmap to flushing list
    
    In the case of an exported pixmap, e.g. with DRI3, it is possible for
    the client to render into the pixmap whilst we are unaware. To serialise
    the xserver and the client, we flush all operations on exported pixmaps
    before talking to the client. In the case of COW however, we did not
    flush the copy-on-write when transferring control to the client, and
    thereby we could capture the modified contents.
    
    Bugzilla: https://bugs.kde.org/show_bug.cgi?id=340202
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=90836
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4a67c534ab756f0eab3b6125f603369804d32b82
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 5 12:44:50 2015 +0100

    sna: Fix definition for testing BLT with y-tiling
    
    commit d1bf75f155f87d3a14d647316a0ba1f40d3957a6
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Mon Jun 1 08:56:43 2015 +0000
    
        sna: Compilation fixes for stable distros
    
    caused an apparent regression by using the wrong ring for detecting
    whether we could program the BCS tiling registers.
    
    Reported-by: Sedat Dilek <sedat.dilek@gmail.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7398cc4801d4afbb6231b2172c10cafde885a614
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 5 12:44:50 2015 +0100

    sna/dri2: Flag APPLY_DAMAGE for stable distros
    
    commit d1bf75f155f87d3a14d647316a0ba1f40d3957a6
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Mon Jun 1 08:56:43 2015 +0000
    
        sna: Compilation fixes for stable distros
    
    set the flag incorrectly - only future Xorg will do the damage
    application itself.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7d30ccea214b54879fe34f0cab123aa3dc1b362c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jun 4 11:32:41 2015 +0100

    sna: Ensure compat_output is sane after sorting outputs
    
    We always arrange for the panels to be first, and we want to use that
    for our compat output.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 1525b0177862b1533232d6de923d40256a738845
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jun 2 15:24:38 2015 +0100

    intel-virtual-output: Fix cloning fixed mode outputs
    
    When using a fixed mode, e.g. a Display without RandR support like
    Xnest, we have to remember to hook up the connection during
    recofiguration of VIRTUAL outputs.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d0ba02666d786f63a88f7c69b82246560521adc7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jun 3 13:07:03 2015 +0100

    sna: Force a configuration reprobe if we detect a mismatch in initial state
    
    If we find that the kernel has more active CRTC than we successfully
    enable, something is amiss and more importantly we are leaving an
    existing active CRTC blank. As a failsafe, if we detect this, fallback
    to doing a full probe for the initial configuration.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b0aa9d349ddf727dc544bc46d066f990d3e42776
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jun 2 11:57:18 2015 +0100

    sna: Reorder can-fence test to account for bit17 swizzling
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=90725#c40
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6ee41d14509a42db580ccdb35c115e249a5ae2b7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jun 2 11:55:18 2015 +0100

    sna: Add some DBG output for can-fence in kgem_init_swizzling()
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit dbfbbcb4b37548172fd6fe9a6976e5ec310477ca
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jun 2 11:50:40 2015 +0100

    sna: Mark GPU as wholly damage when replacing a drawable
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=90725#c37
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c692691029a42749c5567613bf8a3607968e1fa5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jun 2 11:42:08 2015 +0100

    sna: Ensure damage is set to full when marking as clear
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2fa48450c79a27cdd923faa690e5e8e772ae4dad
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jun 2 09:15:09 2015 +0100

    sna: Avoid using NULL pointer inside DBG
    
    When pretty printing the format for DBG, make sure it is not NULL!
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=90725#c32
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 189ad44c94f500f05264d1666b18a96c82cb25ee
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jun 1 17:08:24 2015 +0100

    sna/dri2: Only attempt to change tiling when required
    
    If we have no fence, we then try to discard the tiling. However, the
    change_tiling routine assumes that it is only called when a change is
    actually required. Make it so for dri2.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d1bf75f155f87d3a14d647316a0ba1f40d3957a6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jun 1 08:56:43 2015 +0000

    sna: Compilation fixes for stable distros
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7a371f6befb2e49acbaf59c7adec3bcbbfa32622
Merge: c87e806 b792b2c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jun 1 08:50:31 2015 +0000

    Merge branch 'master' of 192.168.1.213:/usr/src/xf86-video-intel

commit b792b2c0b8e6984a5a45b60e6502cb959db92ba8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jun 1 09:08:52 2015 +0100

    sna/dri2+: The DRI2/DRI3 protocol requires fenced tiling
    
    If we export a surface over DRI2/DRI3, we have to use explicit tiling
    via the kernel. :(
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 085efe68177e252af127a9e7f1186c51e9d68c80
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jun 1 08:59:30 2015 +0100

    sna: Force Linear FB when swizzling is unknown and fencing disabled
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e08589de09b2e27b86321473efd4f29e57a18371
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jun 1 08:54:19 2015 +0100

    sna: Disable tiling assertion with unknown swizzling and white lies
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d1479d8d03f2a1f2c2f0f3f89c5341c65e27d2d5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jun 1 08:42:28 2015 +0100

    sna: Double check that a tiling change request results in a change
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 67185f54ba07205d1df1e5eed30fb287dc2ed087
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jun 1 08:35:10 2015 +0100

    sna: Disable existing GTT mmap when switching to unknown swizzle + tiling
    
    As a consequence of using GPU swizzling without telling the kernel is
    that we must disable GTT access -- especially if we already have a
    linear mmapping.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 14b5ab3fef80afdb204fe399e0340f028ab7839c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jun 1 08:25:12 2015 +0100

    sna: Enable use of GPU tiling even when SET_TILING fails
    
    On gen4+, we no longer need to setup a fence for tiled operations and so
    can program the GPU irrespective of the kernel tiled settings. However,
    this means that we then cannot access the object through a GTT mmapping
    (as we have no fence to do detiling) and nor can we use a WC mmap as the
    swizzle is unknown.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 834bdb0344f1e71c3c0e8c31e47bd44cec28e584
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 31 19:11:54 2015 +0100

    sna: Relax a couple of tiling assertions
    
    Along a couple of passes, we have to set pitch back to 0 when reusing a
    linear surface.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit db78a3449cfba6cfa4760b2333bf7c083eb991d6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 31 12:30:16 2015 +0100

    sna: Keep pitch even for I915_TILING_NONE surfaces
    
    We have to ignore the return value of the pitch for untiled 2D surfaces
    (since the kernel clears the tiling stride parameter).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 9a6c77d7ad9f605cd5af7656c425a1f63104f38f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 31 12:10:32 2015 +0100

    sna: Add a few more asserts for clearing tiling
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 0cd01c04fab59e921e9390813d4014af116504ff
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 31 09:16:36 2015 +0100

    sna: Always apply the SET_TILING results to the bo
    
    Since the kernel can silently change the tiling on the object
    irrespectie of the ioctl's request, we have to double check and remove
    any such invalid object from our lists.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ce4836b091bc10489ab876b2922ca3f004bc5bf4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 31 08:58:02 2015 +0100

    sna: Detect when SET_TILING fails to change tiling
    
    If the swizzling is unknown, the SET_TILING ioctl silently converts the
    request back to I915_TILING_NONE. In order to detect this, we need to
    double check the ioctl parameters.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=90725#c21
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 401b9deef045aedbb60ac4fd3c3cc9efbd8339c1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu May 28 11:24:27 2015 +0100

    sna: Flag disabled CRTC to xrandr
    
    If we disable a CRTC, mark it as such and send an XRR event so that
    userspace can do any recovery, and so that hopefully xrandr remains
    consistent.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5fa114d945fc4ee5d9e89dc18d99584b02baa678
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu May 28 11:23:35 2015 +0100

    sna: sna_set_desired_mode() always returns true, make it void
    
    Since sna_set_desired_mode() always returns true, we can make it void
    and remove some unreachable code.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit fb1643f0f904eb258da71cd0b8deb8d3ec6dafed
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed May 27 07:37:35 2015 +0100

    sna/dri2: Refine ring selection with multiple active rings
    
    The preference given multiple rings is to the previous writer, or if
    none, to the render ring if active.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=90671
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit a6dd2655cb41000943e554ccea16e5781bcbf012
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon May 25 08:25:31 2015 +0100

    sna: Clear encoders request field when updating properties
    
    Reported-by: Dave Airlie <airlied@redhat.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8b7bdff750a98fc7644fc9ab17bedc79b03198b4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon May 25 08:02:46 2015 +0100

    sna: Initialise no-op callbacks early
    
    In case of error, we try to free up memory before trying again. This
    involves callbacks into higher level code - but if we fail early, we
    will not have those hooks installed. Set no-ops stubs early to prevent
    untimely crashes.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=90622#c1
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e617c1941c4e5ee90b69221013aab799eace925d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue May 19 12:14:24 2015 +0100

    sna: Force restoration of SW cursor after HW cursor fails
    
    In order to reset the SW cursor, we need to call xf86CursorSetCursor.
    However, the parameters we need to call SetCursor with are not exposed
    we need to be a little tricky and call a pair of functions that will
    save and then restore the cursor.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 276a628827c126a36f66e5f1b572aff2ff61de04
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue May 19 11:11:21 2015 +0100

    sna: Disable HW cursor if we fail to update it
    
    If we cannot control the HW cursor, flag it as invalid and enable the SW
    cursor next time. The flag will remain set until the next modeset and we
    then try the HW cursor again.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 324ba96520998da3aebb284445e4fea1ea6af739
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue May 19 10:44:49 2015 +0100

    tests/render-trapezoid: Add edge tests
    
    Check fidelity of edge rendering, just a variant of render-triangle
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3852977f14a00db770df7efab79207116aaecbf0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon May 18 09:58:08 2015 +0100

    test: Add a fidelity test for triangle edge rendering
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit fe64672c83e75ccb3f7a1bf37e05df05d0c05392
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon May 18 09:18:41 2015 +0100

    sna: Wrap GetImage with sigtrap
    
    Mostly for completeness, though it is still remotely possibly for the
    dst pointer to raise a SIGBUS (just less likely since it is not a i915
    bo).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d4c82a16bc3ad89a9684c82cd1dd4bcef117ed8c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon May 18 09:16:12 2015 +0100

    test: Remove the blit through a temporary Pixmap
    
    Originally this was inplace so that we wouldn't simply migrate the
    target away from the GPU whenever we inspected results. That is no
    longer a problem and so we can speed up the tests by skipping the
    temporary.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b10ef9cf5c9cc844f432e9024deeb78fa1034a8e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 17 20:45:25 2015 +0100

    sna/glyphs: Improve handling of low bitdepth mask format conversions
    
    We shouldn't just discard the mask if the user requests that we render
    the glyphs through a low bitdepth mask - and in doing so we should also
    be careful not to improve the bitdepth of that mask (since we don't take
    into account the extra quantisation desired).
    
    Testcase: render-glyphs
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6d64063750535f1c2b94e075d1d525ed289821aa
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 17 21:36:50 2015 +0100

    sna: Markup a couple more potential mmap() accesses
    
    All pointer access into a mmap() arena should be wrapped by sigtrap, in
    case the kernel generates a SIGBUS (oom, eio, bugs, etc). Add a couple
    more missing annotations.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 959598cbff68f07d0412c848a857a4d02cf8da5b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 17 13:01:04 2015 +0100

    sna: Check and warn if there exists a GPU error state
    
    When we mark the GPU as wedge and disable acceleration, always check if
    there is a GPU error state and warn if so - it is increasingly rare to
    get a pure EIO from throttling thereby circumventing the current error
    state checker.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 335ac8742e9eadcdf8f087b24f84c7df0fda31c0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 17 08:53:45 2015 +0100

    sna: Wrap CPU access for composite operations with sigtrap
    
    Anytime we access a mmap() we need to be prepared for the kernel to send
    us a SIGBUS, but we were missing a few sigtraps around calls to
    pixman_fill and pixman_blt.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit a16a7e36ca3b22af2978695a57c2f2e9250529a7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 17 08:51:57 2015 +0100

    sna: Only mark wedged checking inside operations as a WARN
    
    These are primarily to serve to detect when we expect to see corruption
    as a result of a badly timed EIO rather than fatal, so downgrade the
    assertion to a warn.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit aa44ba990a4c49fcfc5ed7dbf9968e3c622ffa0a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat May 16 22:05:05 2015 +0100

    intel: Prevent crash with X -configure
    
    When run with -configure, xf86configptr is NULL, so be careful and do
    not dereference it.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f696867c897f1f879c4c03e19690e8217db4d81e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed May 13 13:58:20 2015 +0100

    intel-virtual-output: Record the cursor shape in the DBG log
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 63c43dfa63f4a5ecfa5a00f8b802c56f40d2908c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed May 13 13:44:41 2015 +0100

    intel-virtual-output: Only store cursor image on reference display
    
    We only need a single copy of the cursor image, from which we can create
    all the cloned cursors.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5054e2271210a52bf88b0f12c35d687ce9e8210d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon May 4 14:00:13 2015 +0100

    Remove the driver option to delete connectors on unplugging
    
    With a MST topology change, we can find outputs may disappear. We offered
    a choice as to whether to simply disable them or completely remove them
    from the listing of available outputs.  However, clients never expected
    that their operation on any output could trigger a BadID XError (or that
    there is anyway to prevent race conditions). As such an option was made to
    disable by default, but allow testing complete removal. Now the RandR
    protocol has been clarified such that XID assigned to outputs are now
    permanent, as such the option breaks the spec, so drop it.
    
    See randrproto commit 895ee5264524c7c239ee4ef5e39c4e295323fb51
    Author: Dave Airlie <airlied@redhat.com>
    Date:   Wed Apr 22 10:58:18 2015 +1000
    
        randrproto: clarify output XID lifetimes.
    
        This just makes a note that randr won't make outputs disappear
        dynamically.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>
    Cc: Dave Airlie <airlied@redhat.com>

commit b400dd22c28a08d7644b4ede076be9d8c2b8ca9d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 3 11:58:25 2015 +0100

    sna: Clear has-pinned-batches if we can no longer actually pin
    
    Insert rant about useful kernel interfaces being removed without
    justification.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=88411
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e7016d30f3a0ae817c77ccbd962f776ac3e7e100
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Wed Apr 29 10:33:19 2015 +0100

    backlight: Do not hang forever if helper pid is -1
    
    Backlight helper PID is set to -1 by default, if for some reason it's
    not set, we may end up with waitpid(-1, ...) which will hang forever.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=90230
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>

commit 1a67dacd7514c3327ca0fd27e617309fd437e44f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 27 09:27:52 2015 +0100

    sna: Remove conflicting set-purgeable
    
    A couple of stray set-purgeable points were causing eventual assertions
    that we didn't try and set-purgeable twice.
    
    Minor regression from
    commit 73ae4197d6ebfa0fc1b7c2653b74667a51885a5e
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Fri Apr 24 14:36:50 2015 +0100
    
        sna: Defer marking cache objects purgeable
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit dafd181441f6cde71e6748adab230e851ca5a277
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 24 20:48:14 2015 +0100

    uxa: Fix compilation for bool
    
    ../../../src/uxa/intel_driver.c: At top level:
    ../../../src/uxa/intel_driver.c:769:1: error: unknown type name 'bool'
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 73ae4197d6ebfa0fc1b7c2653b74667a51885a5e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 24 14:36:50 2015 +0100

    sna: Defer marking cache objects purgeable
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f2807d3b5ee3a3ab27ba8216fa02f979338fba87
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 24 13:08:24 2015 +0100

    sna: Reuse compiler attribute fast to build fast_memcpy
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 0bcc3ef02c48edbf838e2665c096cc5cf5cc50c0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 24 12:32:19 2015 +0100

    sna: Mark avx as being a subset of avx2 optimisations
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 9b9643171359194478ab9f7126012b659d2ae7a1
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Apr 24 09:43:37 2015 +0200

    sna: Fix build with gcc 5.0
    
    gcc generates an error at build time because it fails to inline some
    functions:
    
      blt.c: In function 'affine_blt':
      blt.c:980:1: error: inlining failed in call to always_inline
      'bilinear_weight': optimization level attribute mismatch
       bilinear_weight(pixman_fixed_t x)
    
      blt.c:1164:7: error: called from here
          fy = bilinear_weight(y1);
             ^
      blt.c:980:1: error: inlining failed in call to always_inline
      'bilinear_weight': optimization level attribute mismatch
       bilinear_weight(pixman_fixed_t x)
    
      blt.c:1163:7: error: called from here
          fx = bilinear_weight(x1);
             ^
      blt.c:989:1: error: inlining failed in call to always_inline
      'bilinear_interpolation': optimization level attribute mismatch
       bilinear_interpolation(uint32_t tl, uint32_t tr,
       ^
      blt.c:1207:11: error: called from here
          b[i] = bilinear_interpolation(tl, tr, bl, br, fx, fy);
               ^
    
    Do not force inlining of these functions and let the compiler decide to
    avoid the compilation failure.
    
    v2: fix up the other two force_inlines whilst we are here
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>

commit 09d8e5e1b3215c0e58c2ce44048458152c523270
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 23 08:35:52 2015 +0100

    sna/gen6+: Fix BLT src/dst tiling checks
    
    In a couple of the copy paths, src/dst parameters were reversed,
    inverting the direction of the tiling flags.
    
    Reported-by: Andy Furniss <adf.lists@gmail.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=90138
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 64e45993cf9d13b5900dc6b8afacffdfea14fa7f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 22 20:15:38 2015 +0100

    sna: Fix interpretation of SWCTRL
    
    Bspec says it is an override for the source format, irrespective of
    the tiling bit supplied in the command packet. So we need to apply the
    FLUSH+LRI more often.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 52bc0b119cab977b82cbbd96f689b7376b83d6f2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 22 19:45:16 2015 +0100

    sna/gen6: Do not force a blt switch onto a Y-tiled surface
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 45475fb7c9d84579c836b5893571c5185d568198
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 22 19:17:19 2015 +0100

    sna: Update blt fallback to handle Y-tiled surfaces
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4fdd3a714d380afd3d6425aedbbf2ae20180638b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 22 14:08:17 2015 +0100

    sna/gen6+: Discourage use of the BLT with Y-tiling
    
    Somewhere, somehow the first glyph character upload into the Y-tiled
    glyph cache is corrupt since
    
    commit 75d87762471e195dddd73056fc6a06e17db1c8b0
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Fri Apr 17 10:29:28 2015 +0100
    
        sna: Enable blitting with Y-tiled surfaces
    
    I have not spotted whether it is a missing magic bit or a bad GTT path,
    but ideally we don't want to switch to BLT along that path anyway (since
    we are in the middle of rendering with the other engine).
    
    Reported-by: Andy Furniss <adf.lists@gmail.com>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=90138
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 83b8528773a0b1e6655fa87c9645a0062cee1359
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Apr 21 15:28:54 2015 +0100

    sna: Fix ancient typo in DEFAULT_TILING == Y
    
    We could just fix the typo, but that whole if block is redundant.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d8401806b4c2dc41c6054c646080c8f79189b980
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Apr 21 15:17:38 2015 +0100

    sna/dri2: Don't convert from Y-to-X when exporting pixmaps
    
    If the pixmap's GPU bo is already allocated with Y, expect Mesa to deal
    with it rather than convert to X.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 33374755c5462849cb0bb1d549328cd9b00ba1d5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Apr 21 15:02:13 2015 +0100

    sna: Add a define to change scanout tilings by default
    
    Just for testing, you hear?
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 65cc48757e00c81834d39fe90638255723eeb3c6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Apr 21 15:06:18 2015 +0100

    test/present: Do a double flip to test tiling changes
    
    Since the first flip may require a fixup, we will only really know with
    the second flip whether we can start a flip chain with different tiling.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 37cf561fd2f26a51ef60078e2e31ed02e5380c41
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Apr 21 14:33:24 2015 +0100

    sna: Allow flips to continue after successfully fixing up the CRTC
    
    If we receive an error from the pageflip ioctl, we attempt to set the
    framebuffer using SETCRTC instead. This is so that we can transition
    between pitches and offsets for a CRTC. However, the kernel may reject a
    flip also for tiling changes, or for any reason, which we also want to
    transparently handle. Rearrange the error message and flip->blit
    fallback handling to only do so if we try to flip twice (i.e. after
    resetting the CRTC) and we still fail.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 54770d46f10205b4a6d0bc7882d18ae00af47134
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Apr 21 10:16:27 2015 +0100

    tools/dri3info: Include compilation instructions for standalone building
    
    Let the read know how to compile dri3info without having to compile the
    whole of xf86-video-intel
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 75037efcd75f6baa3b48dd818b3efca42087f1b9
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 20 14:54:50 2015 +0100

    test/dri3: Add an explicit DRI3 extension check first
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7eaf593640d4479f850227252fd793bcb55be8d3
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 17 23:45:20 2015 +0100

    sna/present: Reuse last cached swap msc/ust during a flip chain
    
    Querying the known swap values is much slower than not!
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 75d87762471e195dddd73056fc6a06e17db1c8b0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 17 10:29:28 2015 +0100

    sna: Enable blitting with Y-tiled surfaces
    
    Since gen6, there has been a magic register bit to change the
    interpretation of the tiling mode between X and Y for BLT operations.
    With the advent of DRI3 and scanouts supporting Y, enabling support at
    last appears interesting, perhapss even by default for non-scanouts?
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 432e0775ee26a81e8e00f04c6864205d9f0bc2a2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 17 10:21:30 2015 +0100

    sna/present: Check earlier for an incompatilble tiled Pixmap
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4b4bcbfcff25cf2df6fe9c3bba783a4ac1811e2e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 16 21:11:01 2015 +0100

    intel: Fix inconsistent captilisation of "graphics"
    
    As we treat it as a name we should capitilize each word, but we forgot
    that rule (sometimes!) for Broadwell.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3abc3ce3b52a4bd4de4e7e21f05e60c1bd576b6a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 16 20:59:16 2015 +0100

    sna/gen8: reduce CHV VS URB entries to 640
    
    According to BSpec the max number of VS URB entries for CHV is 640.
    
    Based on a patch by Ville Syrjälä.
    
    v2: Start using a GT info block like earlier generations.
    
    Signed-off-by: Ville Syrjälä <ville.syrjala@linux.intel.com> [v1]
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 1e1a7875cf6ff7a46e373ddb5c76621df72b8f74
Author: Ville Syrjälä <ville.syrjala@linux.intel.com>
Date:   Thu Apr 16 20:40:37 2015 +0300

    intel: Add marketing names for CHV
    
    All CHV devices will be branded as "Intel(r) HD Graphics".
    
    Signed-off-by: Ville Syrjälä <ville.syrjala@linux.intel.com>

commit c43617b739e358064396912c7a7a8028ca91d201
Author: Ville Syrjälä <ville.syrjala@linux.intel.com>
Date:   Thu Apr 16 20:40:39 2015 +0300

    gen8: Fix the YUV->RGB shader
    
    Use the correct register (Yn_01) with first half of the
    Y samples instead of using the register (Yn_23) with the
    second half twice when computing the green channel.
    
    Also use the Yn_01 register name instead of Yn for the red
    channel as well, just for a bit of extra consistency.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=89807
    Signed-off-by: Ville Syrjälä <ville.syrjala@linux.intel.com>
    Tested-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 57252b63f92c8f58cb62c28461d86becf463302b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 16 14:29:53 2015 +0100

    sna: Force GTT fallback if we cannot BLT or RENDER download
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5df16db52ec994fce2f3af952ad08a13c9c700aa
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 16 14:22:33 2015 +0100

    sna/dri3: Mark incoming sna_pixmap->flags
    
    We use the flags for deciding how to operate on the GPU bo, so we should
    set them!
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 66f3db6789727b99ec34afe3ceaecc9e549e55ee
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 15 08:31:35 2015 +0100

    sna: Use addfb2.1 for extended scanout support
    
    If at first you don't succeed, try, try again.
    
    The kernel API is lame and requires a new interface for something that
    is designed to be supported through the old interface...
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c87e80637a077e76b6d354f8976c93f9bceafcbb
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 15 08:31:35 2015 +0100

    sna: Use addfb2.1 for extended scanout support
    
    If at first you don't success, try, try again.
    
    The kernel API is lame and requires a new interface for something that
    is designed to be supported through the old inteface...
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 37ce4dd0a02dd5b33017904580219a6541da9428
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Apr 14 23:43:19 2015 +0100

    sna: Leak the mmu_notifier for sync userptr
    
    Since creating/destroying the mmu_notifier for sync userptr is fairly
    expensive, leak the test userptr object to keep it around for the
    lifetime of our process.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2faf255100331ae17dbc5f9072edb4fd9dd68773
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Apr 14 22:01:22 2015 +0100

    sna: Reverse the size check so that it works
    
    I managed to confuse myself when testing since I had to force the
    addition of default modes...
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 26fd6bec113194c471c5d9e1b414c0a1824c5a23
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Apr 14 20:47:26 2015 +0100

    sna: Add common widescreen resolutions
    
    Currently we add fake modes to cater for applications that want to
    change the screen size but limit themselves to only those that are
    available, and do not wish to either use RandR scaling or their own. For
    widescreen panels, these 4:3 aspect ratio modes require panel fitting
    and so are less than satisfory. Since we add fake modes, let's add a few
    common widescreen modes as well (choosing the right aspect ration for
    the panel).
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=37858
    References: https://bugs.freedesktop.org/show_bug.cgi?id=29890
    References: https://bugs.freedesktop.org/show_bug.cgi?id=89996
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4c277bc43d958b256d15f72aec884bb921f4ad0a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Apr 14 15:33:57 2015 +0100

    sna: Make ioctl invocation more compiler friendly
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 9c109f3dc56621215e580e74a6161f00035bdac3
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 12 21:15:54 2015 +0100

    sna: Mark the GPU as available before doing the mode restore on VT enter
    
    Sometimes we want to render with the GPU when doing a mode switch, e.g.
    if we need to initialise an output surface. To do so, we need to prepare
    the acceleration layer first.
    
    Lots of thanks to Vasily for tracking this one down.
    
    Reported-by: Vasily Khoruzhick <anarsoul@gmail.com>
    Bugzilla: https://bugs.archlinux.org/task/43534
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5d1ffd6f34d6280dbc792a8251c6442f480631e7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 12 20:52:27 2015 +0100

    sna: Mark the fallback TearFree flip path as pending
    
    An oversight when enabling efficient sharing of the shadow_crtc (i.e.
    clients flipping to one monitor).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f74121e222b025ad8d8180850541740f76575f17
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 12 17:54:49 2015 +0100

    sna: Set addr for the 64bit self-relocation
    
    Copy-paste fail.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit aff63c65bb61e1373bcf477f8d223cb2ab4e84b9
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 12 15:01:47 2015 +0100

    sna: Fix self-relocations fixups for 64-bit addressing
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8350f1e07386d9a7a5078ae5993622112d8f52d7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 12 15:07:15 2015 +0100

    sna: Tidy DBG_NO_SHRINK_BATCHES code
    
    We can combine the llc-path with the DBG path and trim a little of the
    ifdeffery.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit fbefc8f2bd4242c3f01b02e25276340237b34a88
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Apr 9 11:45:27 2015 +0100

    uxa: Do not register hotplug without RandR
    
    When using Xinerama, RandR is automatically disabled, and calling RR
    routines will trigger an assert() because the RR keys/resources are
    not set, leading to an Xserver abort.
    
    Hotplug makes little sense without RandR, so no need to install a
    udev monitor if RandR is not available, as done in sna.
    
    v3: Rebase onto backwards compatible rrPrivKey detection [ickle]
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 148777f02883adfbd8418070eb27547136d59f8c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 9 11:43:23 2015 +0100

    sna: Fix RandR detection to work before dixPrivateKeyRegistered
    
    Since dixPrivateKeyRegistered was only introduced in 1.10, we need an
    alternative probe for older Xservers.
    
    Suggested-by: Olivier Fourdan <ofourdan@redhat.com>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 15354751b7298ca06e608ea061e776268e5116a8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 9 10:40:59 2015 +0100

    tools/intel-virtual-output: Update DBG comment to include DRI3 transport
    
    The Pixmap may either be being used for DRI3 or SHM transport.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit fad92cec33bb9bde9e701a3b299fc40918945546
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 6 18:48:52 2015 +0100

    sna/present: Free Timer when converting to vblank event
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c47fd1dcada882757573261a0d714bccad5aa21c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 6 14:00:44 2015 +0100

    test/present: Synchronize MSC notifiy modulus test to the vblank
    
    As the test presumes we can queue all the modulus queries within the
    same vblank, we can improve matters by synchronizing to the next vblank
    first.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e74ff581449e92d7933da1b5df6680cb880fc454
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 6 13:58:35 2015 +0100

    sna: Force the TearFree redisplay when populating a rotated configuration
    
    We have to disable the "shadow idle; skipping" test if the CRTCs are
    showing stale content following a sna_crtc_attach().
    
    Reported-by: Chris Bainbridge <chris.bainbridge@gmail.com>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=89904
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit a00ed98131d0316d8be1c6c850667d04be397e5a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 6 11:16:39 2015 +0100

    test/present-speed: Disable idle event reporting for no-copy overhead test
    
    Reduce the overheads in the server for better measurements.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c2da68871a33612abd8a4fddbabec6118c6ea1be
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 6 09:52:59 2015 +0100

    sna: Clear the new scanout along all paths before attaching
    
    Make sure we clear the scanout even after the error paths before
    attaching the shadow buffer (in case it is full of unwanted junk).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d348f897c83632eb2b1742d664422d67fd9079e6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 5 21:33:40 2015 +0100

    test/present: Expland MSC accuracy test
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6de85a1e60f50d525c28da2f29466c40ce3f39bb
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 5 20:49:31 2015 +0100

    test/present: Include composite redirected windows in the test matrix
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 56801202ded1f11608ff08e69c95f0a43c758322
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 5 19:41:31 2015 +0100

    sna/present: Use a vblank wait to fix up a timer firing too early
    
    In cases of stress, we use a timer to create a fake vblank event and
    then we adjust the timer when it fires to match it up with the CRTC msc.
    However, sometimes we fire before the vblank but less than a millisecond
    and so below the precision of the timer causing us to send notifies too
    early. Use a blocking vblank wait to fixup these rare cases.
    
    Testcase: present/notify/accuracy
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 990ca393fd58e809d74ee416a0d9a7a33afc7ea3
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 5 17:13:32 2015 +0100

    test/present-speed: Reneable normal testing
    
    Oops, debug leftover.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f4588b64e294ede0b21d7aebc0c1ffcbd6045d51
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 5 17:03:02 2015 +0100

    test/present-speed: Export the pixmap over DRI3
    
    Improve the DRI3 simulation by exporting the Pixmap to force DRI3
    syncflushes.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit be0fc3ce20fda064d68f38e24717552222d1fd74
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 5 15:46:27 2015 +0100

    sna: Block signals while releasing cursor under modeset
    
    Otherwise we may process a SIGIO moving the cursor away from the CRTC
    causing us to remove the cursor and then process a stale pointer inside
    the modeset after the signal is complete.
    
    Reported-by: Chris Bainbrigde <chris.bainbridge@gmail.com>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=89903
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit af2da325748d238dee42467e4d2295c65cdce18e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 5 10:50:07 2015 +0100

    test/present-speed: More measurement for different swap methods
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit fd12095f8994c98c8b30bb7f22d9b06e6f124119
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 5 09:26:50 2015 +0100

    test/present: Also test swaps on windows (as well as full screen flips)
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7cf670228eec058a97f6450df46a1a47cb080583
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Apr 4 20:58:24 2015 +0100

    sna/dri2: Prevent the sw cursor from copyig to a buffer as we discard it
    
    During swapbuffers, the sw cursor tries to write to the old buffer.
    Ordinary this is not an issue as we are discarding it, but under
    TearFree that write causes us to instantiate the shadow buffer with a
    possible recursion into set_bo and mayhem.
    
    v2:
    
    commit 226a58bc592d4ed305b7ad0e460f1ee2548e0ddf
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Sat Apr 4 20:58:24 2015 +0100
    
        sna/dri2: Prevent the sw cursor from copyig to a buffer as we discard it
    
    Tried to fix it by disabling SourceValidate. However, it a direct hook
    into the Damage code by miSprite that triggers the copy. Since there
    appears to be no way to intervene, we just mark that copy as internal
    and ignore it.
    
    Reported-by: Chris Bainbridge <chris.bainbridge@gmail.com>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=89903
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 209d120dbf9b32d3b96a0f857e4f658f6a554c02
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Apr 5 09:56:08 2015 +0100

    sna: Initialise hwcursor to true
    
    So we don't disable the hwcursor when we have a rotation set but not all
    pipes activated.
    
    Reported-by: Chris Bainbridge <chris.bainbridge@gmail.com>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=89903
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 226a58bc592d4ed305b7ad0e460f1ee2548e0ddf
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Apr 4 20:58:24 2015 +0100

    sna/dri2: Prevent the sw cursor from copyig to a buffer as we discard it
    
    During swapbuffers, the sw cursor tries to write to the old buffer.
    Ordinary this is not an issue as we are discarding it, but under
    TearFree that write causes us to instantiate the shadow buffer with a
    possible recursion into set_bo and mayhem.
    
    Reported-by: Chris Bainbridge <chris.bainbridge@gmail.com>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=89903
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 108a09e3db6c9cf86bf0b4eb8574ccc22555edb2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Apr 4 20:11:24 2015 +0100

    sna: Add DBG for why we fallback to sw cursor
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=89903
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 61da72c0761181fb1589e0bae2d1025633ca5071
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Apr 4 19:37:11 2015 +0100

    test/present-speed: More buffers required to hit maximal framerates
    
    5 buffers are required for swap elision, plus an extra or two for IPC
    scheduling jitter.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ea545e05ecefbafd48cac59cce674b3f08a3f130
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 3 14:37:50 2015 +0100

    sna: Rewrite swizzling funcs using macros
    
    Save a little space at the expense of a little readibility.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit de61dae3bb64137db311cc75f3b084f991da2179
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 3 11:11:09 2015 +0100

    sna: Implement missing 9^10^11 swizzle mode
    
    As found on my gm45...
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8d85793b08c202de7195f384e1698f3045fa70e5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 3 00:01:31 2015 +0100

    configure: Replace hardcoded pkg-config --exists with PKG_CHECK_EXISTS
    
    Suggested by Emil Velikov:
    
    	Normally hard coding pkg-config is considered a bad idea. Please
     	try PKG_CHECK_EXISTS - it would work like a charm when
    	cross-compiling.
    
    	Cheers
    	Emil
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 459efa036e64bd4875b79d42bdd8416ede2223d3
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 2 22:50:54 2015 +0100

    test/dri2: Reset swap-interval after testing async swapping
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3c3f7d7df4cfb6e1f22fe850f3cf35c6e334b4a1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 2 22:50:19 2015 +0100

    test/dri2: Check vblank waits
    
    Make sure that waiting 60 times for a vblank, 60 msc pass
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ef8f5236f2b7698d026be42de99cb8e7f86a4a6b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 2 15:14:24 2015 +0100

    sna/dri2: Fix multimonitor swap elision
    
    We were not updating the window->crtc for the immediate swaps with the
    result that after switching CRTCs, we were requesting a vblank on the
    wrong pipe and triggering an error path (forcing the blit and negating
    the elision).
    
    Testcase: test/dri2-speed
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 0814dc41c3fa23c1d6d20f5696a9fb87671ae0c7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 2 15:13:43 2015 +0100

    test/present-speed: Include a measure for fence signalling overhead
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f63f739fecf925d3765006a46b8b021d0008a041
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 2 08:55:19 2015 +0100

    sna: Do not call an extra busy ioctl for scanout flushs
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e47eb0c5e588a6cfc4e6f12824814f11e802ed51
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 1 23:00:57 2015 +0100

    sna: Don't unroll BLT points
    
    The compiler is smarter than I am; unrolling hurts here.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7df58456b8d99a9953a871c656657cbc923dc238
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 1 22:59:20 2015 +0100

    sna: Add DBG option to disable manual detiling
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b56b63bf937bd3ecaf47cbfc7d0c15f16155fd01
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 1 18:13:50 2015 +0100

    sna: Relax a y-tiling fb assertion
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f00599f971cdde1c5006764f4b6ef08ad4a4eb17
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 1 17:45:31 2015 +0100

    sna/dri: Avoid using the BLT for DRI2CopyRegion if no semaphores
    
    We expect mesa nowadays to preferentially use the render pipeline for
    doing its clears and so want to avoid handing it back an active BLT bo
    if we don't have semaphores (as that would cause a sync).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 61d2baa430dba6eb282167c61d7df1034d5acca7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 1 15:52:52 2015 +0100

    configure: Make tools/PROGRAMS agnostic to tools presence
    
    In order to make tools indivdiually selectable for compiling, we don't
    want to override earlier tools - so use '+=' rather than a plain '='
    when adding each tool to the set of PROGRAMS.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit cdac2b369ad0b88bc6765617a29fc14cc9543afc
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 1 15:50:46 2015 +0100

    sna: Relax unclean rules to check busyness on all foreign pixmaps
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 35537ec4bfed4118725b4871cb99326c85a4b2d3
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 1 15:07:46 2015 +0100

    sna/present: flush is not required
    
    present.flush is called on the Window after a copy from a Pixmap is
    completed - which will be naturally flushed anyway. What the API should
    be passing is the Pixmap, since we do want to flush the operations from
    it before sending the idle event. C'est la vie.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2f047c62783a187067921e1aaf5572fb8647bd84
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 1 12:39:48 2015 +0100

    tools/dri3info: Query refresh rate on Primary monitor
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 745c21fb1aa1fcd54e9a9aeaa7fe6877af39f2f1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 1 00:34:00 2015 +0100

    sna: Fixup inverted logic for new bo
    
    We only want to inspect the busy status of bo we have not yet added to
    our execbuffer.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 61f8dcdfa5972cfd918fc60504345482fedd1a65
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 31 22:08:55 2015 +0100

    sna: Consider idleness of both rings if we need a semaphore
    
    When emitting batches early for improved GPU/CPU concurrency, we only
    want to do so if the target ring is not busy. However, if the batch
    requires a semaphore, we also need to consider the other ring as well.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 56f9d2c1d9770437e82f07f5a40b52940a2e8ef7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 31 15:34:16 2015 +0100

    sna: Flush BLT operations to an idle GPU
    
    We improve dispatch latency if after creating a command buffer we
    immediately submit if the GPU is idle. This improves concurrency as we
    continue to build the next command buffer as the GPU executes and helps
    prevent needlessly using one engine for too long (i.e. sometimes we may
    be able to execute the work much early and do the ring switch cheaply).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 68632e100034ae7cf3086a85f5d6f38cd9a94adc
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 31 15:01:10 2015 +0100

    sna: Use more explicit retire-requests after syncing
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8b358076f2b2d6a6d69e7511735316dc51dd9ec5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 31 12:58:19 2015 +0100

    sna: Query the engine residency on foreign bo before use
    
    Since knowing which ring the bo is currently active on is important when
    considering the impact of semaphores on the next operation, be sure to
    query it on foreign bo before we use them.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ef24cb1b223486d7dfe57f33c28d8692f9857c98
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 31 11:58:26 2015 +0100

    sna/gen6+: Prefer the BLT for small copies
    
    Even on GT3, it is preferrential to use the blitter if the copy is small
    (due to the latency in execution).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5a872056de61ca8724d5d476783c4dcc8c1a6af7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 31 11:58:26 2015 +0100

    sna/gen6+: Prefer the BLT for small self-copies
    
    Even on GT3, it is preferrential to use the blitter if the copy is small
    (due to the latency in execution).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 1be5b715827ef2bbc75ef795c301a1a7ba6e5f09
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 31 09:59:58 2015 +0100

    Add TILE property support (for MST tiled monitors)
    
    Based on the patch for modesetting (and lots of work) by Dave Airlie
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8dc716e8667f918af5febc82ed301aeff59d86f0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 26 22:31:35 2015 +0000

    sna: Limit the last gasp execbuf try to ENOSPC
    
    Disabling the outputs and trying again can only possibly help in the
    case of fragmentation. In all other failures modes (typically GPU hang)
    it just causes a slow flash of the display.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c05c6abd089cc81c39f78513b614023c471d097a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Mar 28 23:58:35 2015 +0000

    sna: Mask the batch length
    
    It's white lie that only is technically required for gen2, and works
    around a massive performance hit on gen7.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit dbdcae9f8afb9964becd29200d7d6936e8269baa
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 25 20:44:01 2015 +0000

    sna: Refresh properties even if we skip the detection probe
    
    Properties may refresh quickly, more often than the output status
    changes. We want to query the properties without doing a forced probe,
    so make sure we refresh the values if the user requests a property.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8f11f2bdcdc7d84b11134c9e7d15df888f2b6f3c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 25 13:16:56 2015 +0000

    Use AC_FUNC_ALLOC
    
    The preferred all-inclusive method for finding alloca().
    
    Reported-by: Richard Palo <richard@netbsd.org>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=89762
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit aa40f990142eb165ee7f60f08e9616bc5bebdebe
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 25 13:16:56 2015 +0000

    Use AC_HEADER_MAJOR to find how to include major()
    
    We need to include <sys/mkdev.h> on Solaris.
    
    Reported-by: Richard Palo <richard@netbsd.org>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=89763
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d85e68e2d310a5646e4e71a06edf2b21b1d18688
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 25 13:16:56 2015 +0000

    sna: Add include <alloca.h> for compiling on Solaris
    
    Reported-by: Richard Palo <richard@netbsd.org>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=89762
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d377fd3d11a6ed29f8bce9e7b05a8db82e33764e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 24 21:05:58 2015 +0000

    sna: Detect Y-tiled scanout feature
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 019402f8ca670234908df00f52650d2173a5011a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 24 15:25:54 2015 +0000

    test: Test tiling across DRI3/Present
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 44452825fb862c81957f53e04f739e2d96864f91
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Mar 20 13:13:43 2015 +0000

    sna: Remove bogus assert(output->randr_output)
    
    During shutdown, we may get backlight uevents after removing the
    randr_output.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 9e39bea9d3cfb1a05b3908e51fab649c1b9f6301
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Mar 20 11:50:38 2015 +0000

    tests: Add basic present benchmark
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7fe2b2948652443ff43d907855bd7a051d54d309
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 19 23:14:17 2015 +0000

    sna: Protect against ABI breakage in recent versions of libdrm
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit bacaf7f18c2f4d3b5cb6bd6145dfb79fa4096759
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 17 09:45:09 2015 +0000

    sna: Use struct pixman_f_vector for compatibility with older pixman
    
    Or else face compile failures:
    
    blt.c: In function 'affine_blt':
    blt.c:1403:3: error: unknown type name 'pixman_f_vector_t'
    blt.c:1407:4: error: request for member 'v' in something not a structure or union
    blt.c:1408:4: error: request for member 'v' in something not a structure or union
    blt.c:1409:4: error: request for member 'v' in something not a structure or union
    blt.c:1411:3: warning: passing argument 2 of 'pixman_f_transform_point_3d' from incompatible pointer type [enabled by default]
    In file included from /usr/include/xorg/miscstruct.h:52:0,
                     from /usr/include/xorg/regionstr.h:52,
                     from /usr/include/xorg/region.h:50,
                     from /usr/include/xorg/window.h:51,
                     from /usr/include/xorg/input.h:55,
                     from /usr/include/xorg/xf86str.h:38,
                     from sna.h:43,
                     from blt.c:32:
    /usr/include/pixman-1/pixman.h:247:15: note: expected 'struct pixman_f_vector *' but argument is of type 'int *'
    blt.c:1413:7: error: request for member 'v' in something not a structure or union
    blt.c:1415:7: error: request for member 'v' in something not a structure or union
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 9d0d78230aaf8863a96d75e8b57bb62e51121b8a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Mar 13 23:07:59 2015 +0000

    sna: Skip inplace operation to a busy clear GPU bo
    
    Since clearing is a relatively trivial operation, allow us to do the
    clear to a CPU bo rather than block on the GPU.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d8dd2b88a1f2bca63a2a6f42af035fd9fb1f685f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Mar 13 22:27:31 2015 +0000

    sna/gen6+: Demote BLT ring switching priority if semaphores are disabled
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 66cb6c23d110300fff0235fd07408362e8491339
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Mar 13 15:44:44 2015 +0000

    sna: Start demoting some assertions
    
    A few assertions are there to catch less desirable behaviour rather than
    outright errors. For these, just grab the backtrace and continue.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7863efebf5bee0dbdad55e5402e02413e26f7a4f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Mar 13 15:21:47 2015 +0000

    sna/gen6+: Relax assertions in light of !semaphores
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 359f12312ece78333162eb8fd191968a4b0030b6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Mar 13 15:21:26 2015 +0000

    sna: Fix assertions for transformed cursors
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c2381ac065e0d7fc39ae029045eda54b36766324
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Mar 13 14:39:56 2015 +0000

    sna: Remove redundant RRGetInfo on hotplug discovery
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2f1fb20d89b032f56737530ade3a22564e08cf4d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Mar 13 13:14:27 2015 +0000

    sna: Explicitly compute whether the transform is affine for HW cursors
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit bc84ba6f97b2cdd5d9f2d0c4b5c7b6532ed5d0e6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Mar 13 12:12:21 2015 +0000

    sna: Fix computation of transformed cursor size
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 557ffa3bacd8e673fe8d4f141a74b037eb9de095
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Mar 13 12:08:04 2015 +0000

    sna: Cross check that we only have an affine transformation for HW cursors
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d867d48bb63273e72d45baaaf53cb23f0e493de5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 12 22:29:29 2015 +0000

    sna: Apply affine transformations to HW cursors
    
    Until now we only applied pixel-exact rotations to the cursors. However,
    this left the cursors ignoring scaling and so appearing incorrect on
    outputs with transformations applied. An extra complications comes from
    making sure that the scaling routine is signal safe.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 56ebdb7d95a9da8fb66ae82d3f546d15bd89b5a6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 12 14:27:59 2015 +0000

    sna: Disable hw cursor when random transforms are applied
    
    Ideally, we would iterate over each CRTC and check that the transformed
    cursor is still valid for the HW plane and then remember to transform
    the cursor before displaying. Disabling the HW cursor if a non-native
    transform is the first step in correcting the display of said cursor.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 341654dc276d254aa23593efdb8e4c27a9ca1f77
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 12 13:50:39 2015 +0000

    sna: Compute half resolution modes
    
    Sitting here with a 3200x1600 panel but no 1600x900 intermediate mode,
    and I am too lazy to add it by hand.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 71318389bedc87d3a2ea386343c371e5caed2880
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 12 12:39:55 2015 +0000

    sna: Futureproof acceleration backend selection
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 15c307d70e00bc035bb61be5d8b6f727925e3d34
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 10 08:48:48 2015 +0000

    sna: Force frontbuffer to CPU for randr fallback
    
    When we are using the fallback method, we need to make sure the source
    is on the CPU.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=89053
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 535b030c02c3769dbf537babb686a03544d9e8a3
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Mar 9 16:33:06 2015 +0000

    sna: Strengthen assertions that batches are idle before overwriting
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f7c4bc7c5f5a194e1794644c0641eb735f97b297
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Mar 7 21:09:39 2015 +0000

    sna/gen6+: Demote priority of COPY_LAST for copy boxes
    
    Even if we expect to flush at the end of the operation, we still want to
    consider semaphores before overriding the engine selection.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit aefedd2baff8beaa5a5548bcf7a126ab6fca310b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Mar 7 10:58:53 2015 +0000

    sna/gen6+: Prefer the BLT for small copies
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8e8eac509731747f1076bcaf1cbadac1b6daca0b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Mar 6 09:11:11 2015 +0000

    tools/cursor: Inlcude stdlib for malloc declaration
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6522fedaa1023939c046fb6e9a1d2f48d30a37c8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 5 14:18:07 2015 +0000

    sna/dri2: Don't dereference a NULL drawable on client shutdown whilst flipping
    
    A dropped if(!NULL) check from the previous patch.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 72d208a7f2f0e8f2d93483e535154f34a8a26d81
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 5 12:26:15 2015 +0000

    sna/dri2: Perform swap elision on windows for swap-interval==0
    
    In order to be more like Windows and inflate benchmark results.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7ae299be60ef3ab4f8cc49edd9d5a14d826d5583
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 5 08:39:31 2015 +0000

    sna: Remove the flush after waking up between clients
    
    In the normal command processing stream, we will have lots of
    opportunity to ask whether we should be batching requests together. If
    we wakeup without doing any work, then we will check inside the block
    handler whether the GPU is idle and flush then.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit db82617464e55432522e6199a88408ff0187f6ff
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 4 17:12:30 2015 +0000

    sna: Decouple RandR pointers early in CloseScreen
    
    RR resources are freed before CloseScreen (as they are a ServerClient
    resource), but on entering our CloseScreen callbacks we are left with a
    set of stale pointers. Decouple those before proceeding so that we are
    not tempted to dereference them.
    
    Bugzilla: https://bugs.archlinux.org/task/43906
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 88e615425bd61856c3f039127fb90592dfac22df
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 4 15:28:49 2015 +0000

    configure: Make sure that BUILD_TOOL_CURSOR is always defined
    
    Building intel driver with --disable-tools fails with following
    
      configure: error: conditional "BUILD_TOOL_CURSOR" was never defined.
    
    Reported-by: Tomas Pruzina <pruzinat@gmail.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=89425
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 413ca2b88f6398d68d2a170bb24b1ea643b6ff30
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 4 13:40:12 2015 +0000

    sna: Sync RROutputProperty values with the kernel
    
    Currently we only set the RR value for the output property on creation,
    but we update that value every time we query the connector. To sync our
    value with RR, we need to change the output property value.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8d76f90e2cd560c315595e679679cefbcf422fb4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 4 11:19:09 2015 +0000

    tools: Add simple tool to retrieve the current cursor from X
    
    Slightly more funky would be to poke around in the CRTC, but that should
    require master. As it stands this should help verify that what X is
    supplying to the driver matches user expectations
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3e390ec4110519746f2edbb3c38a40f0fc415430
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 3 12:59:52 2015 +0000

    sna/dri2: Remove limiting pending swaps on redirection changes
    
    If we limit the swaps, then doing xrandr --output -off causes unity to
    misrender. Not quite sure why, but the revert is easy.
    
    Fixes regression from
    commit 88e84320a3a8b3faf20941d666ab846fe12b7a67
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Tue Feb 24 12:44:19 2015 +0000
    
        sna/dri2: Flush triple buffer swap on [un]redirection
    
    but we still keep the async-swap fixes.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=89371#c14
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 555f7f4f54d60e99c8c00d7b3b1e574dc27ec68b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 3 12:47:24 2015 +0000

    configure: Include the xorg-server version in the summary
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit a5978074dba200b4059f53ab94b9c34863250520
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 3 12:25:39 2015 +0000

    Convert from RRSetChanged() to RROutputChanged()
    
    RRSetChanged() is much more recent than RROutputChanged(), and
    RROutptChanged() allows for more finer grained updates. Switch to
    RROutputChanged for compilation with xorg-server-1.14 and older.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 78aaba45c9ccc56061597ee9c5e1c822566a0da3
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 3 11:41:36 2015 +0000

    sna/dri2: Pre-fill new backbuffers
    
    When we enable buffer-age and Clients start taking advantage of that by
    only submitting trimmed flips (SwapBuffersWithDamage) we don't want to
    then lose that by randomly injecting new buffers into the mix (thereby
    forcing the client to repaint the entire buffer and us to damage all
    outputs). As new buffers are relatively rare, especially in a
    steady-state game scenario, spend a few cycles to initialise the new
    buffer with the current back buffer contents.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8c2e9c2adcdd31107218e371f605c40dd625f075
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Mar 2 12:46:15 2015 +0000

    sna/dri2: Disable backend application of damage
    
    In the future, I anticipate moving the application of damage into the
    core dri2 (so that clients can specify the damage region for flips).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 254bbd6f8381a7930236de10bf699da371cb6ae4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 3 07:32:24 2015 +0000

    sna: Detect absence of DRM_I915_GEM_PIN
    
    Don't error out if the kernel no longer supports pinning (despite it's
    usefulness it has been removed) and hope that the kernel just works now
    on 830gm/845g.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2c698d9ed3a363417c793b00d201431edbacfcb2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Mar 2 22:12:24 2015 +0000

    sna/dri2: Fix format comparison
    
    If multiple Clients intermix DRI2GetBuffers and DRI2GetBuffersWithFormat
    we can end up with format mismatches. Rectify this by checking the
    bitsPerPixel of the buffer instead.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b7e28618cdf7f4123ed47cd626e3535b4ed98f56
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Mar 2 09:34:19 2015 +0000

    sna: Tweak find clip box asserts
    
    Reordering the asserts to save one predicate!
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit cb2269d1308f2a410508aafecc8b0ee51959afcf
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Mar 2 09:08:54 2015 +0000

    sna/gen3: Disable fences associated with vertex buffers
    
    Could gen3 actually be trying to read these through a fence?
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=89334
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f6ba71ac194a19c80aa64f4769f76a47ebb7bd16
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Mar 1 15:47:50 2015 +0000

    sna: Unrecurse clip box search
    
    Unwind the trivial tail recursion from the clip box bisection and add a
    couple of assertions on the inlined fast-paths.
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=89295
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 9fb815462902a1d2047e135cf5037f47eb0d83d2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 27 13:56:03 2015 +0000

    sna/gen7+: Allow GT3 to overlapping copies via an intermediate
    
    This benefits most when GT3 is coupled with eLLC and WT, but it is just
    marginally a win over a BLT otherwise.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 445423170d24a8a9f57ac887921cdecf4377f7ca
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 27 10:15:04 2015 +0000

    pciids: sync with kernel 0dc6f20b9
    
    No new ids, just fixed descriptions.
    
    Sync upto
    kernel commit 0dc6f20b9803f09726bbb682649d35cda8ef5b5d
    Author: Rodrigo Vivi <rodrigo.vivi@intel.com>
    Date:   Wed Jan 21 11:46:32 2015 -0800
    
        drm/i915/bdw: PCI IDs ending in 0xb are ULT.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 53d804b134494be8a324781283faecb2968f6511
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 25 20:25:07 2015 +0000

    sna: Avoid asserting that a foreign bo is idle
    
    Once again we fall foul of a foreign bo that between consecutive calls
    to the busy ioctl may be used by another client. Relax the assertion
    that on the status of the bo being retired and double check afterwards.
    
    Reported-by: Jiri Slaby <jirislaby@gmail.com>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=70461#c101
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 369ceec0e4910ba2c37736a59c55c0d6c26433bf
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 24 15:25:40 2015 +0000

    uxa: udev integration depends on fstat and sys/stat.h
    
    src/uxa/intel_driver.c: In function 'I830HandleUEvents':
    src/uxa/intel_driver.c:738:14: error: storage size of 's' isn't known
    src/uxa/intel_driver.c:746:2: error: implicit declaration of function 'fstat' [-Werror=implicit-function-declaration]
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ea09d830c8651fe854ba772a9e28e8a5f601b1c1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 25 17:20:28 2015 +0000

    sna/trapezoids: Restore lost xTrapezoidValid() checks
    
    When fixing up the sample projection of the trapezoids, we lost the
    safety check that the trapezoid was valid.
    
    Fixes regression from
    commit bca08dc4155c0ee304c60340ccf95fe7b03ac11b [2.99.917]
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Mon Sep 29 19:30:03 2014 +0100
    
        sna/trapezoids: Fix loss of precision through projection onto sample grid
    
    Reported-by: Jiri Slaby <jirislaby@gmail.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=70461#c95
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2b978c71e4a9f54e728fb8abf2734c260ee74916
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 25 14:29:03 2015 +0000

    tools/intel-virtual-output: Use xcb_dri3_id
    
    xcb exports the extension structs for querying whether they exist and
    sharing the results.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6bf6b4b7509768d10bf31128ce6e52cb060fd177
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 25 11:25:10 2015 +0000

    sna: Check types on querying RAM
    
    Turns out to be a false alarm as the machine I was looking at only had
    4GiB. I thought I was looking at another one and started panicking about
    where had all the memory gone...
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 41e559f57e5284462ffb46f8617aeb9f56f97937
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 25 09:01:25 2015 +0000

    sna: Update the active_scanout flags on async flips
    
    In order to keep our sanity checks and buffers in order, we need to
    remember to mark the new frontbuffer as the active scanout after an
    asynchronous pageflip.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 1ae0dc460d3a6b0aed763ab4f8f8af02d2af1940
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 24 22:56:46 2015 +0000

    sna: Clamp aperture size to 32bits
    
    Internally we only use 32bits for limiting the maximum object size
    (both for CPU and GPU allocations) so to prevent overflow limit the
    reported aperture size.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 98245a5cff095a3a50cfe6fa41a0233f5bd6f75e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 24 22:36:11 2015 +0000

    sna: Improve DBG messages for MST probing
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 88e84320a3a8b3faf20941d666ab846fe12b7a67
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 24 12:44:19 2015 +0000

    sna/dri2: Flush triple buffer swap on [un]redirection
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 12af8a575d1518d40416f83195049157c3a062a5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 24 15:25:40 2015 +0000

    sna: udev integration depends on fstat and sys/stat.h
    
    src/sna/sna_driver.c: In function 'sna_handle_uevents':
    src/sna/sna_driver.c:759:2: error: implicit declaration of function 'fstat' [-Werror=implicit-function-declaration]
    
    Also take the opportunity to include udev support in the configure
    summary.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 872a296850312956851f61cacb4f66c63ff990b8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 24 08:58:48 2015 +0000

    sna: Discard addition of drawable offset if 0
    
    Missing trim of "add 0" from
    
    commit 0b7a6666f82b4fa07f9c9d9a9c1819efc363b31b
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Mon Jan 5 14:00:44 2015 +0000
    
        sna: Partially unroll conversion of rectangles to boxes for fills
    
    not all redundant +(dx,dy) were dropped.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit fef0f3dc0ca8d7f6e50fd841a7fff23a4d357121
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Feb 21 17:08:06 2015 +0000

    sna: Add missing 'break' from last patch
    
    Converting from
    
    switch(value)
    {
    case 1: return 1;
    ...
    default: return -1;
    }
    
    you must remember to insert the breaks!
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b6d4f49176c6177561b760b116ae3e5f0a39aa95
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Feb 21 16:50:50 2015 +0000

    sna: Cache the output status and modes for 15s
    
    As the output configuration rarely changes, and is normally accompanied
    by a hotplug event, we can cache the last probe for a small number of
    seconds. If a hotplug event does fire, in the worst case by the 30s
    output polling thread, then we reset the cache and force the probe. This
    should improve application (and desktop) startup times as they often
    seem to do many full xrandr probes (rather than query current status).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 09b0ab9b43846b464170941fd0eaec90b588d610
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 18 19:16:29 2015 +0000

    uxa/dri: Drop dependency on stdbool
    
    Copying the bool is_level() without including stdbool.h causes it to not
    compile on some machines. Just convert back to the old faithful Bool.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 996736af717fb6ea0d59a81c63f7f29968767810
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 18 16:12:21 2015 +0000

    sna: Rename 'sna_output_panel_edid' to 'sna_output_add_default_modes'
    
    The criteria for adding the modes is not associated with panels and
    edids, so the name is quite misleading. We add any missing default modes
    if we have a panel fitter and the output itself has not declared them
    (via its EDID).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 50f911b19f71b5d4117b88fa129a4533f7a1a28a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 18 10:13:00 2015 +0000

    sna/present: Fixup a few DBG
    
    event_id is now an array - but the misprint was hidden on 64bit systems,
    the warning only apparent because of the pointer mismatch on 32bit
    systems.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e293991f408ba7ba4fd02b7bcfeff0051f9eb8f4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 18 09:59:58 2015 +0000

    sna: Reuse the old cursor on the current CRTC
    
    We only want to prevent sharing of physical handles across CRTC (on old
    kernels). If we already have one assigned to a CRTC we know that it is
    unshared and can keep using it.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 127aae5a72a69df325fed0b63d345e81583d5ca1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 16 21:37:35 2015 +0000

    tools/intel-virtual-output: Check for DRI3 more carefully
    
    Using xcb, we cannot simply call xcb_dri3_query_version() without it
    terminating the connection if DRI3 is not enabled on the target display.
    Oops.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=89172
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 53c435c6cd74fcd06e3f0d393295798f5af864c0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 16 15:57:14 2015 +0000

    sna/present: Only share vblanks on the same CRTC
    
    Remember vblanks are private to a CRTC, the same MSC on another CRTC may
    fire at completely different times...
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 10e40489e22f7e65c919082ffe2a37d5f000dcee
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 16 12:29:24 2015 +0000

    sna/present: Try exchanging the Pixmap with a scanout-ready bo
    
    Try to avoid more clflushing on the current Pixmap if we have a
    scanout-ready bo in the cache. We also note that since we unflip before
    any other drawing takes place, we do not need to mark the flipped Pixmap
    as being pinned to the scanout.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 1877c8f5081f3192dd30bb1162efd6acb1957487
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 16 11:35:27 2015 +0000

    test/present: Compact flip queue checks
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 1c16a91aafa2dff3b41dafa31f233316b595f124
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 16 11:22:26 2015 +0000

    sna: Skip an async flip request to the same bo
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 93b94b96c6518365fc082a33b17980b018f1e378
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 16 10:59:11 2015 +0000

    sna/present: Append duplicates onto queued vblanks
    
    If we have multiple events for the same vblank, append the notification
    to an existing vblank. This is particularly useful as we it ensures that
    we then report notifications in the same order as queued.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b9eeb9dd8434251310b292e3a3af31ce87d93b13
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 16 09:45:17 2015 +0000

    test/present: Tighten MSC modulus computation
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3382bd78d9e9885a7714ebbfd777a03ee8708a01
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Feb 15 19:20:35 2015 +0000

    test/present: Test notifier accuracy
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5fc2628e803998c9b5b8c9bdd88dc34a46b31e2e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Feb 15 14:43:27 2015 +0000

    sna: Use shadow_enabled to prevent TearFree recursion
    
    At times, we want to clear pending flips from inside TearFree, and thus
    need to disable recursion. Currently we dance with shadow_damage, but
    now we can just migrate over to using the shadow_enabled flag.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3fc942b3744958fe9570bda2dfbc47a1a0dbae57
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Feb 15 09:30:52 2015 +0000

    sna/present: Avoid tricks with the TearFree flag
    
    Modifying the flag may cause havoc if we need to modeset whilst Present
    is in control as the CRTC will be setup without reference to TearFree, but
    then when Present unflips, we restore the stale configuration. So let's
    have a separate flag just to disable TearFree flips when a Present flip
    chain is active.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 74553bf4d25f5876ef6e682d06f5825feb9e1da4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Feb 14 22:31:06 2015 +0000

    sna/present: Integrate into TearFree, take 2
    
    Following on from the previous attempt is the realisation that we can
    simply disable TearFree during a Present flip queue, and re-enable
    TearFree upon unflip.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c30af937f8d634d0055358cb69db2896cf595983
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Feb 14 21:53:41 2015 +0000

    sna/present: Disable hardware async flips with TearFree
    
    These two don't mix, so remove the claim that we do support async flips
    when TearFree is enabled.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 9a311f9da612ba02b24458f6a40b6a5445ad4869
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 13 14:03:16 2015 +0000

    sna: Throw away the TearFree damage if it grows too big
    
    The Damage layer is slow, so reduce the amount of work it has to do by
    explicitly throwing away any information other than the bbox.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit adaf0a2c6189ae0460219b9b47df54defd64011b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 13 09:13:33 2015 +0000

    sna/present: Hook into TearFree
    
    For the duration of the Present flip chain, replace our frontbuffer with
    the Client's Pixmap. Before any attempt to draw into the real
    frontbuffer, Present will unflip back to the TearFree front+shadow.
    However, it does give the Client direct access to the scanout through
    their Pixmap (effectively disabling TearFree on behalf of the Client).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 42ebe2ef9646be5c4586868cf332b4cd79bb4618
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 13 08:06:43 2015 +0000

    uxa: Remove the filtering of bogus Present MSC values
    
    If the intention was to filter the return values from the kernel, the
    filtering would have been applied to the kernel values and not to the
    incoming values from Present. This filtering introduces crazy integer
    promotion and truncation bugs all because Present feeds garbage into its
    vblank requests.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 35ab0afd04c3d526a26b2ef0d937c25d7eead506
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 12 21:10:25 2015 +0000

    test/present: Automatically disable DPMS
    
    DPMS plays havoc with Present timings, make sure the screen doesn't turn
    off.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 9eb0ab15b1ab09cd6a4e8666b6f488fad1dc36b4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 12 17:05:52 2015 +0000

    test/present: Look for MSC wraparound
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 254f2f2f4b0a4deccec847e46086881c5a2681b1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 12 17:03:46 2015 +0000

    test/present: Check a simple double-buffer sequence
    
    Just check that we can do a present roundtrip in time to submit a new
    frame on the next vblank.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 92f74186b0b329e7ede53153a6b5f953c5cad2a1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 12 14:24:38 2015 +0000

    test/present: Include test for timing accuracy
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 9d4df75edb21b8fdef4b45cc8cda114ca55c54cb
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 12 13:46:05 2015 +0000

    test/present: Check modulus computation
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 51f184edfb2c09ea512c45cfe468a68406a8f6da
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 12 12:49:57 2015 +0000

    test/present: Tighten the accuracy requirements
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ac1eb7f7c976b45b63b0ca3000ddfe1be2ccce62
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 12 11:23:07 2015 +0000

    test/present: Test accuracy of long pauses
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 818b596a6a4dddea29f92f52d73a3577ef16c8b2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 12 12:12:29 2015 +0000

    sna/present: Store target_msc for DBG output in flip handler
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 147e190d1e18d3ac6dc23aa4e493eec28aa75d1d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 12 09:51:38 2015 +0000

    sna: When turning off outputs whilst DPMS off, update the right counters
    
    Whilst the outputs are hidden, if we want to disable a CRTC, we want to
    manipulate the hidden counter as opposed to current front_active
    counter.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8348927c37b0550ce666d1156b0860b15de2a35a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 10 16:54:07 2015 +0000

    sna/present: Handle fake RRCrtc
    
    Be sure we don't crash if the user requests presenting on one of our
    fake RRCrtcs.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 688f5e9bd7d3e1162db44ba341ac43e054aba237
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 11 16:12:41 2015 +0000

    sna/present: Compensate for time elapsed since last swap
    
    When computing the delay for the fake flip, compensate for any time
    elapsed since the last frame in order to hit the desired vblank more
    accurately. A side-effect of this is that we may now compute 0 delay
    timers which require special handling.
    
    Testcase: present-test/accuracy
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6b6ab5407219ba29bae19386067a9eefe355ad03
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 11 12:32:53 2015 +0000

    sna/dri2: Refactor immediate swap scheduling
    
    Allow a request to swap on the next frame to be considered by the
    immediate handling code by refactoring the target msc computation.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7e1671b15e8e480457a31036e105f3691c0964d6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 11 11:26:35 2015 +0000

    sna/dri2: Queue a flip via a vblank event if we have outstanding flips
    
    If we swap between Clients, or even Windows, then we may have a flip
    still pending completion in hardware but no longer tracked in order to
    release the freed state. In this scenario, queue the flip via a vblank
    event.
    
    Testcase: dri2-race with non-immediate flips
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8b8b1021f45ea7e47c1825f88b50bda98a28d47c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 11 11:14:33 2015 +0000

    test/dri2-race: Mix immediate flips with delayed flips
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit fc010846b13dcb757f030c06f25415c200f61f71
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 11 11:05:12 2015 +0000

    test/dri2-race: Actually queue a number of future WaitMSC
    
    In order to have outstanding WaitMSC when the Client quits or the Window
    is destroyed, we need to use the xcb version so as not to immediately
    block on the play.
    
    And also print keepalive dots to console as test progresses.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4f5d7825dfc57a5f892f3f903cbfa36abf3c13ca
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 11 10:34:47 2015 +0000

    test/present: Return the correct error counter from for_each_crtc
    
    When the xserver is fixed and we no longer block for ever inside the
    test, we can see that the test itself falsely reports failure!
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7671e5cb7b0b8c7d914b8e659d9deddad2c55bb2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 11 10:26:13 2015 +0000

    sna: Handle double failure to flip
    
    During flip failure recovery, we try to queue a second flip in order to
    generate the flip completion event. If that fails, we need to abort the
    flip entirely.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 426a3afcc6ec96b8d4bb93262557bd036e00718c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 11 09:48:00 2015 +0000

    sna/present: Prevent DoS from exhausting the kernel vblank queue
    
    The kernel caps the number of vblanks per client to 128. There are
    already reports from the wild that Present clients are running foul of
    that limit, so supplement it with a timer fallback.
    
    Testcase: present-test with future flips
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 0b7a6666f82b4fa07f9c9d9a9c1819efc363b31b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jan 5 14:00:44 2015 +0000

    sna: Partially unroll conversion of rectangles to boxes for fills
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 8ef3fdacac05ee93b685a93f6664696d026e889e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 10 15:00:55 2015 +0000

    sna: Reshow cursors after VT switch
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 61e957cb5f4ba31b00d7b283d852ad972b850074
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 10 14:03:11 2015 +0000

    Enable support for render-nodes by default with DRI3
    
    DRI3 can use render nodes if provided by the kernel, so enable it.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5568b24a328d13494a26cffb6e6f2b7168475aee
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 10 14:01:17 2015 +0000

    dri2: Disable integration with render-nodes
    
    The executive decision has been made to render DRI2 inoperable with
    render-nodes, so keep on passing the master device path to clients.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d1ebd27a31ad3fa76db408b05dea2a5c70cac75c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 10 13:50:31 2015 +0000

    sna: Prefer first active CRTC for offscreen drawables
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d50eb8d57a3ecb4577b9e556d9e38bf80b408f77
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 10 12:22:59 2015 +0000

    intel: Fix checking for compatible render node
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 88db217705f6b59f75524a47a3e720d9ef0d37b3
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 10 12:12:48 2015 +0000

    tools/dri3info: Match fd against render nodes
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 27ededdfc7a7727288f187aeebb06f6d118fd1c7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 10 12:10:56 2015 +0000

    tools/dri3info: Query the kernel driver name
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 928ff25430b8cddc92ccdc47975d6558658018a0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 9 17:08:57 2015 +0000

    tools: Add rudimentary dri3info
    
    A simple tool just to check if the target Xserver offers dri3.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f7f68d50797f0a5e6a3c7f931c827845464acd3f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 9 10:32:48 2015 +0000

    sna: Convert pixel values into ARGB values for render operations
    
    When converting from a Pixmap into a Solid, we need to remember to
    convert from the stored pixel format into the a8r8g8b8 used by the solid
    fill.
    
    This was exposed by
    
    commit aef2f99d051dfa37717e5d6d6de9b548d706a520
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Tue Feb 3 21:31:16 2015 +0000
    
        sna: Convert CompositeRectangles ADD white to SRC white
    
    but is a regression from
    
    commit 31a4c7bc13c5f4560482b450b9ee4788a58930cd [2.99.912]
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Fri Apr 4 10:46:48 2014 +0100
    
        sna/gen2+: Replace composite sources with solids where possible
    
    Reported-by: andrew@atomspring.com
    Reported-by: Matti Hämäläinen <ccr@tnsp.org>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=89030
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 733a88bda7a654473ffc5961d08ac246ca12a28b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 9 10:24:26 2015 +0000

    sna: Tidy composite operator reduction for CompositeRectangles
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 111847108db7c1c634afca87f1d69589a88a696d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 9 10:23:06 2015 +0000

    sna: Match more classes of opaque composite masks
    
    If we apply the mask clipping first, we can be sure that the samples are
    all from an untransformed mask and so we can check the is-clear? hint.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5b033d638bbf2c0b841088ca75f9eb8de5852cb5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Feb 8 22:13:35 2015 +0000

    sna: Avoid accessing past the end of the clip boxes for incremental clipping
    
    During incremental clipping of the trapezoids, we can assign the end
    BoxPtr to begin, and so we should be careful not to dereference that
    pointer (as it points passed the end of the clip boxes).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 357a798156b10af440dc674cbe580aa127793444
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Feb 8 21:57:51 2015 +0000

    sna: Check against last clip box (not past the end of the boxes)
    
    The end BoxPtr actually points to one past the end of the clip boxes, so
    in order to inspect whether the line is after the clip region, we want
    to look at the last box, i.e. the box before. We also only want to
    ignore the clip if we do not intersect at all, otherwise we need to find
    the start of the clip row.
    
    Reported-by: Matti Hämäläinen <ccr@tnsp.org>
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 0c2ff5532c79029a8c3c50a83d3f719cc5c5171e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Feb 8 15:21:24 2015 +0000

    sna/present: Fallback to first available CRTC if none overlap Window
    
    In order to handle PRIME offscreen Windows nicely, tie their
    presentation into the Primary CRTC (if available).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit bc8c1618011e8050ab1b66384a608c8c5a33de28
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Feb 7 15:57:48 2015 +0000

    sna/present: Always store sna backpointer in vblank event closure
    
    This is primarily defensive paranoia in case we see multiple unflip
    requests.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ae05f74e4efc69be05d53b7e419b66c2ff36f4bd
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Feb 7 15:48:50 2015 +0000

    sna/present: Try to use async flips for unflip
    
    If possible, we want the restoration of the Screen Pixmap to be fast,
    and so we want to preferably use the immediate asynchronous flip.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6e3f45e028b36f5c1c95fe4f7e01d41d0887134d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Feb 7 10:21:03 2015 +0000

    sna: Use PrimaryOutput as CRTC source when drawable is offscreen
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 26ba2ba6e7169a099558092f31eaf97944cc3562
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 6 23:03:11 2015 +0000

    uxa/present: Fix flip_count for aborting on failed flip request
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c7517c4fe2c3025b08fa72ed81886b9544d008ba
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 6 22:16:26 2015 +0000

    sna/present: Restrict pending flip check to enqueueing
    
    Present checks for a flip-compatible Pixmap prior to deciding whether to
    queue the flip after a pending flip, and at that point we do not want to
    reject a potential flip due to outstanding flips. That is only of
    restriction only applies when we request the kernel to perform the flip,
    so more the check to the corresponding position.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 934733e7c7e027e0bc73a6c102962b745ee3737a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 6 15:59:09 2015 +0000

    sna: Separate per-CRTC client bo from the TearFree cache
    
    Using the same member as both an override and a cache in different
    modes leads unsurprisingly to confusion.
    
    Fixes regression from
    commit 3cfde9f04362a858ddfe7990109147e32eed516c
    Author: Chris Wilson <chris@chris-wilson.co.uk>
    Date:   Tue Jan 13 13:50:08 2015 +0000
    
        sna: Only instantiate the frontbuffer on the GPU if used
    
    Reported-by: Chris Bainbridge <chris.bainbridge@gmail.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=89007
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5ed83687722f7238bfc0307022183710d4d3a70f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 6 13:41:16 2015 +0000

    sna/trapezoids: Use incremental region clipping for spans
    
    Within a span, we have the advantage of knowing that we only need to
    intersect one box with the clip region, and that box has monotonically
    increasing y. This avoid having to compute RegionIntersect for every
    span element which was very slow (e.g. libreoffice).
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e0d9953e3b9cb159cce825fd473c4248efdd8d12
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 6 12:27:48 2015 +0000

    sna: Only do COW creation on read-only migration if forced
    
    For reads, we can use the existing clone -- except if the migration is
    required to return a unique GPU handle to the pixmap.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4c9af314774d366583411f44b0c9b7dd1a1198f2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 6 08:05:15 2015 +0000

    uxa/present: Do flip returns 0 on failure
    
    Oops, inverted error handling lead to use-after-free and calamity.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ee42e106fed8e04c61fed84cd1f75cd757afb093
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 5 13:33:54 2015 +0000

    test: Tighten present checks to catch CRTC interchange bug in a single pass
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ca71ee06851058b86405c677c204790d0fb94e36
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 5 08:40:01 2015 +0000

    uxa/present: Do not allow the unflip to fail
    
    As we cannot propagate the failure for unflipping back to the caller, we
    must ensure that the CRTCs are correctly reset if the attempt to flip
    back to normality fails.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit cec34132a7884a5b5b02bae0096b560f522fffb8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 4 22:02:37 2015 +0000

    sna: Add some DBG for why a DoCopy might be skipped
    
    This captures a bug in transitioning from gdm to gnome-shell where the
    present_unflip copy back onto the Screen Pixmap fails.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 7dd16e56841e4b79eab88df06938f7766d8b7206
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 5 08:12:56 2015 +0000

    sna: Clear the resized framebuffer if wedged
    
    We always try to make sure the scanout is initialised before use, but if
    the GPU is wedged we need to fallback to use the CPU to do the clears.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit f93aab9bbc3ecc64533a2eb646b7a6209ddd492f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 5 07:55:08 2015 +0000

    sna/present: Queue the unflip if we have flips outstanding
    
    Rather than synchronously wait in the unflip for the pageflips to complete
    by forcing the modeset, try to queue the unflip to happen after the pending
    flip completes.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6ba3bd9dfd6f3249cbcc2de8df607fec21af9a98
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 4 12:12:13 2015 +0000

    sna: Use local defines for compilation on older distributions
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c6dd23ce1146f699620de9e1b9f4646c312e334c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 4 11:13:19 2015 +0000

    sna: Always mark the virtual outputs as disconnected until used
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5fad8d852762628770f70c6d2a7bcfbded609595
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 4 11:05:00 2015 +0000

    sna: Mark initial output status as unknown
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=88960
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d7bcb7bcbf96eae6f4cf131ac2bc166cd820b43e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 4 10:41:11 2015 +0000

    sna/trapezoids: Amalgamate adjacent lines
    
    If we have two scanlines with identical extents and coverage, we can
    amalgamate them into a set of multi-row boxes. For simplicity, we only
    compare with the last box (assuming that the majority of such cases are
    "rounded-rectangles" where we have a large vertical area with no
    variation and can coalesce into a single box). This operates as a second
    pass to the scanline converter itself coalescing pure-vertical regions.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit db629a38342883176d58357fa014176c9e45115d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 4 09:34:14 2015 +0000

    Allow runtime selection between DRI levels
    
    Rather than imposing a maximum DRI level at compile time by compiling
    out unwanted protocol handlers, default to limiting it at runtime so
    that we can switch between any level.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit aef2f99d051dfa37717e5d6d6de9b548d706a520
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 3 21:31:16 2015 +0000

    sna: Convert CompositeRectangles ADD white to SRC white
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3855a728e5522452f0d6208e569ef23389d32d20
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 3 17:06:27 2015 +0000

    sna: Always restore the scanout on DPMS on
    
    As we may exchange the frontbuffer whilst the outputs are hidden (DPMS
    off), when we turn them back on, unless we force the CRTCs to be
    updated, we may end up simply showing a stale scanout buffer not the
    current frontbuffer. If the two are same, it will just be a kernel
    no-op.
    
    Reported-by: Jiri Slaby <jirislaby@gmail.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=88826
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 70cb682662f9c54bcc7cc0eda029c21efbb4947f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 2 10:03:33 2015 +0000

    uxa/dri2: Recreate the triple buffer across a mode change
    
    If the mode changes whilst we have a pending flip, we may reinstall the
    previous scanout buffer as our next back buffer despite it no longer
    matching.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6d2754b1902e8bce37818c854fb890400b27343e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jan 31 21:32:19 2015 +0000

    Unify Option "DRI" parsing
    
    Allow Option "DRI" "[23]" to also work with UXA.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit dac01d0839123e87ebc04fb2dc046d321805c6db
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jan 31 10:55:44 2015 +0000

    sna: Mark the bo as clean after the kernel reports it idle
    
    After querying for an idle bo and retiring the associated requests, we
    must be careful not to confuse ourselves with exported bo becoming busy
    again.
    
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=70461#c83
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 5edab91b1ed6d2f1c88389a1c58f7a7812817923
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jan 31 01:29:31 2015 +0000

    intel: Try to load one AccelMethod if the .conf doesn't match
    
    If you mistype or make the wrong selection in the AccelMethod override,
    you can end up with a non-booting system, so lets always try to start
    something!
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6db906ea8188cd7f731e5ef7391115ee8f5c17c8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jan 30 16:49:06 2015 +0000

    uxa/dri2: Reimplement triple buffer support
    
    Since xorg-server-1.12.0, Xorg has supported adjusting the client swap
    limits allowing us the implemention of triple buffered flipping with
    accurate event timestamps. Given that the current implemention has an
    issue tracking the right GEM name across composite unredirection, it is
    an approximate juncture to tackle both bugs.
    
    Bugzilla: https://bugzilla.gnome.org/show_bug.cgi?id=742911#c1
    Testcase: dri2-race + gnome-shell
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 102a091f5a92cd812dc9f7f8c872cd31cc1b0f2b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jan 31 00:16:19 2015 +0000

    sna/dri2: Rearrange asserts for greater coverage
    
    Always check that the reused DRI2Buffer matches the associated name, and
    not just for back buffers of a window.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit e427bb4e4187a9fd251ddeb420a1e26ca281cbff
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jan 30 14:08:54 2015 +0000

    test/dri2-race: Race against CloseDisplay and also test WaitMSC
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d909c460743a0cabc5c0ed30e063e99af7b26b17
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jan 30 13:24:42 2015 +0000

    uxa: Fix error handling for failed pageflips
    
    Lots of issues found when trying dri2-race, mostly resulting from
    queueing too many flips at one - which itself is buggy. However, we
    crashed whilst trying to recover from the kernel reporting the error.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c2f30a539cfb5808dbee19b7cc5d878bb7381a60
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jan 30 13:12:20 2015 +0000

    uxa/dri2: Make vblank/flip handlers static
    
    These are no longer called directly from outside intel_dri.c and so we
    can make them static.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit fa5a8c61d1ac6f90b1f4544e1734308fbdba3c0d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jan 30 13:10:55 2015 +0000

    uxa/dri2: Reset swap_info->type after a failed flip submission
    
    As we set the type prior to attempting to queue a flip, we need to then
    reset the type if that attempt fails and we need to fall back to a
    vblank handler.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit c0610c76b7164ee687092fec3602284f506816a7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jan 29 23:56:06 2015 +0000

    sna/dri2: Smooth out delivery of triple buffer SwapCompletions
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit dc51886c0c637a1da94e6379f183fc32ac345df6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jan 29 23:55:19 2015 +0000

    sna/dri2: Fix use of stale flip_pending after removing window
    
    Testcase: dri2-race
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 1030705cdc7725ee821cf10be9c3cb0aeb31564c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jan 29 23:11:49 2015 +0000

    sna/dri2: Fix interoperation between keepalive and fake-triple-buffering
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 58fe4089789278a80e422a1e2ab45af4bcdcf34e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jan 29 11:45:50 2015 +0000

    sna/dri2: Keep the per-drawable swap cache alive for 50ms
    
    The purpose is to keep the recent history of buffers for a DRI client
    for tracking the relevant age.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 2e7ae76038c808d80c39dfaa56ad4648cd94e7fc
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jan 28 11:44:41 2015 +0000

    test/dri2: Use xcb for more accurate timing of SwapBuffers
    
    To do SwapBuffers correctly requires a Swap/Get buffers combination, and
    this is easiest using xcb rather than xlib.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6f6190abcfc3abdefdb2826415e242749fcfb9f8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jan 28 11:22:57 2015 +0000

    sna: Clear the per-crtc shadow buffer if they are clipped
    
    Before we present a buffer on the CRTC, we try to make sure it is
    initialised with the current contents. However, if it is larger than the
    screen then not all the buffer may be initialised and so we need to
    clear it first.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 4bbd1023675f4724bd17de50dd750514626104bf
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jan 27 08:49:41 2015 +0000

    sna/dri2: Check for comparable back/front pitches more carefully
    
    Suppose for a moment that we don't have a DRI2Buffer associated with the
    Drawable just yet... This could happen after a Composite redirect as the
    front buffer may created (and so associated with the new Pixmap) after
    the back buffer is recreated.
    
    Reported-by: Tomas Pruzina <pruzinat@gmail.com>
    Bugzilla: https://bugs.freedesktop.org/show_bug.cgi?id=88814
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b8d52b0edd2ad6a2513d37001ee9d8f67c9acaa7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jan 26 21:40:20 2015 +0000

    sna: Log maximum number of CPU threads
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d2b7d78064ca224bdcc365bede1b16991d43caa8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jan 26 21:30:44 2015 +0000

    sna/dri2: Use existing busy state if semaphores are disabled
    
    Undo d16ac1f30bb (sna/dri2: Prefer to use normal selection criteria for
    CopyRegion on small GT) to keep on the current ring as the external bo
    if semaphores are disabled.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 64e9c79017cb4bdb2dc18920ba9dcea0f9cea1a8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jan 26 13:10:21 2015 +0000

    legacy/i810: Expand mask to match unsigned long
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 33f7d5e4283d5c63eb1af287fece6af0f8e51feb
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jan 26 13:10:21 2015 +0000

    sna: Expand mask to match uintptr_t
    
    Let's make sure we mask all the uintptr_t bits.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 53e825d6cfe49a4db5588718ea910c46d656ecfa
Author: Patrick Welche <prlw1@cam.ac.uk>
Date:   Mon Jan 26 12:25:42 2015 +0000

    configure.ac: pwd doesn't take an argument
    
    bash built-in doesn't give an error, but real pwd does, and the
    argument is unnecessary.
    
    Signed-off-by: Patrick Welche <prlw1@cam.ac.uk>

commit 75fcda80580445be2030a83f3595a217c8982f8d
Author: Patrick Welche <prlw1@cam.ac.uk>
Date:   Mon Jan 26 12:25:41 2015 +0000

    uxa: fix XVMC = no build
    
    Signed-off-by: Patrick Welche <prlw1@cam.ac.uk>

commit ac90648ec7cdc9cc0514105f30a83df04ea1e1a5
Author: Patrick Welche <prlw1@cam.ac.uk>
Date:   Mon Jan 26 12:25:40 2015 +0000

    backlight.c: test for features
    
    Signed-off-by: Patrick Welche <prlw1@cam.ac.uk>

commit 913afaf249205141e2690c2bb76bd24268ae695f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jan 26 09:40:52 2015 +0000

    sna: Tweak treatment of DPMS mode to be consistent at all layers
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=88794
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 6c8d98436a207d179a6b3735928d03742cd3bf3a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Jan 25 13:28:00 2015 +0000

    sna/gen6+: Tweak engine placement when considering src/dst combinations
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit ed19b160089640c2e1167332b00ffe1e569a48dc
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jan 23 11:08:37 2015 +0000

    sna: Assert that the shadow buffer has a compatible pitch to the front
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit b388172076c1664e949cd81feb94c60e81a90d86
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jan 23 10:54:57 2015 +0000

    sna: GETPROPBLOB only works with exact length matches
    
    If the blob is smaller than the space we offer for the read, it skips
    the read. So make sure we repeat the read in this case as well.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 619d165eed414ecbb0e7d22763f1c2f82763f9ec
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jan 23 08:42:56 2015 +0000

    sna: Add a fallback DBG for the git version
    
    In case the version numbering is disabled, like on Arch, include it
    anyway in the full debug log.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 684e921a5442c0d7afedd27b7b85719d8195c6ee
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jan 22 15:26:00 2015 +0000

    sna/dri2: Only preserve back buffers with the same pitch
    
    We can only pageflip if we don't change the pitch, otherwise we
    simulate the pageflip with modeset. The idea is that once we have
    exchanged the buffers, we will quickly settle down to a steady state
    scenario where each buffer has the same pitch. We can encourage this
    further by only keeping those buffers around that do have the same pitch
    as the current front.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 3cb0672586a55effa89a59c9a97744e225a05dac
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jan 22 21:02:42 2015 +0000

    sna: Reorganise assertions when retiring idle bo
    
    References: https://bugs.freedesktop.org/show_bug.cgi?id=70461#c83
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit 653b8a4d83210187f6ef90f017598d8ebb45de27
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jan 22 16:36:27 2015 +0000

    sna: Declare outputs as hidden at start
    
    Required for our internal bookkeeping of DPMS events.
    
    Reported-by: Jiri Slaby <jirislaby:gmail.com>
    References: https://bugs.freedesktop.org/show_bug.cgi?id=70461#c79
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

commit d16ac1f30bb12d4830f6ed05c161b1175e77b019
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jan 21 10:14:41 2015 +0000

    sna/dri2: Prefer to use normal selection criteria for CopyRegion on small GT
    
